<?php
/*-----------------------------------------------------------------------------
  pToDo - Login Modul
  -------------------
  Verarbeitung des Login
  ----------------------
  Lizenz:

    Copyright (C) 2005 - 2006 Andreas "Pr0g" Droesch

    pToDo ist Freeware und darf ausdrcklich weitergegeben werden, sofern
    dies kostenlos und in unvernderter Form des Scripts geschieht.

    Der Autor haftet nicht fr Schden, die durch die Nutzung dieses Scripts
    entstanden sind!
  -----------------------------------------------------------------------------
  Author:

    Andreas "Pr0g" Droesch
    http://pr0g.net,
    webmaster@pr0g.net
    All Rights reserved.

  Version:

    siehe index.php
-----------------------------------------------------------------------------*/

  // Sicherheitsschutz
  if (!defined('IN_PTODO')) {
    die;
  }
  
  // Autologin
  if ((isset($_COOKIE['ptodo_login_id']) || $cfg['guest_mode']) && !isset($_GET['login'])) {
    if ($cfg['guest_mode']) {
      $redirect = true;
      $_SESSION['ptodo_user_logged'] = 1;
      $_SESSION['ptodo_user_id'] = -1;
    } else {
      $redirect = false;
    }
    $sql = 'SELECT user_loginkey FROM ' . TABLE_USERS . ' WHERE user_deleted=0 AND user_id=' . $_COOKIE['ptodo_login_id'];
    $query = @mysql_query($sql);
    if (@mysql_num_rows($query) > 0) {
      $row = @mysql_fetch_array($query);
      if ($row['user_loginkey'] == $_COOKIE['ptodo_login_key']) {
        $_SESSION['ptodo_user_logged'] = 1;
        $_SESSION['ptodo_user_id'] = $_COOKIE['ptodo_login_id'];
        setcookie('ptodo_login_id', $_COOKIE['ptodo_login_id'], time() + 2592000); // Cookies auf 30 Tage verlngern
        setcookie('ptodo_login_key', $row['user_loginkey'], time() + 2592000);
        $redirect = true;
      }
    }
    if ($redirect) {
      header('location: ?' . str_replace('fid=', 'redirect_fid=', $_SERVER['QUERY_STRING']));
    }
  }

  // Login berprfen
  $error = '';
  if (isset($_POST['send'])) {
    $sql = 'SELECT user_id FROM ' . TABLE_USERS . ' WHERE user_name="' . $_POST['username'] . '" AND user_password="' . md5($_POST['password']) . '" AND user_deleted=0';
    $query = @mysql_query($sql);
    if (@mysql_num_rows($query) == 0) {
      $error = $lang['login_error'];
    } else {
      $row = @mysql_fetch_array($query);
      $_SESSION['ptodo_user_logged'] = 1;
      $_SESSION['ptodo_user_id'] = $row['user_id'];
      if (isset($_POST['autologin'])) {
        $key = uniqid('');
        $sql = 'UPDATE ' . TABLE_USERS . ' SET user_loginkey="' . $key . '" WHERE user_id=' . $row['user_id'];
        @mysql_query($sql);
        setcookie('ptodo_login_id', $row['user_id'], time() + 2592000); // Cookies fr 30 Tage setzen
        setcookie('ptodo_login_key', $key, time() + 2592000);
      }
      header('location: ?' . str_replace(array('fid=', 'login=1'), array('redirect_fid=', ''), $_SERVER['QUERY_STRING']));
    }
  }
  // Fehlerausgabe vorbereiten
  if (!empty($error)) {
    $error = '<div class="info_warning" style="text-align:center">' . $error . '</div><br />';
  }
  $url_query = str_replace('&', '&amp;', $_SERVER['QUERY_STRING']);
?>
<div id="div_login">
<b style="text-decoration:underline">pToDo <?php echo $lang['login']; ?>:</b><br />
<br />
(<?php echo $lang['login_info']; ?>)<br />
<br />
<?php echo $error; ?>
<form action="?<?php echo $url_query; ?>" method="post">
<table cellpadding="2" cellspacing="0" style="margin:0 auto">
<tr><td><?php echo $lang['user_name']; ?>:</td><td><input type="text" name="username" /></td></tr>
<tr><td><?php echo $lang['password']; ?>:</td><td><input type="password" name="password" /></td></tr>
<tr><td><?php echo $lang['login_auto']; ?>:</td><td><input type="checkbox" name="autologin" /></td></tr>
<tr><td style="text-align:center" colspan="2"><br /><input type="submit" accesskey="s" name="send" value="<?php echo $lang['login']; ?>" /><?php echo ($cfg['guest_mode'] ? '<br /><br /><a href="?' . str_replace('login=1', '', $url_query) . '">' . $lang['login_guest'] . '</a>' : ''); ?></td></tr>
</table>
</form>
</div>