<?php
/*-----------------------------------------------------------------------------
  pToDo - ToDo Listen Modul
  -------------------------
  Verarbeitung der ToDo Listen
  ----------------------------
  Lizenz:

    Copyright (C) 2005 - 2006 Andreas "Pr0g" Droesch

    pToDo ist Freeware und darf ausdrcklich weitergegeben werden, sofern
    dies kostenlos und in unvernderter Form des Scripts geschieht.

    Der Autor haftet nicht fr Schden, die durch die Nutzung dieses Scripts
    entstanden sind!
  -----------------------------------------------------------------------------
  Author:

    Andreas "Pr0g" Droesch
    http://pr0g.net,
    webmaster@pr0g.net
    All Rights reserved.

  Version:

    siehe index.php
-----------------------------------------------------------------------------*/

  // Sicherheitsschutz
  if (!defined('IN_PTODO')) {
    die;
  }

  // Integer validieren
  if (isset($_GET['tid'])) {
    $_GET['tid'] = (int)$_GET['tid'];
  }

  // BBCodes einbinden
  include('bbcode.php');

  // Projektname ermitteln
  function GetTitle() {
    $sql = 'SELECT navitem_title FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['tid'];
    $query = @mysql_query($sql);
    $row = @mysql_fetch_array($query);
    return $row['navitem_title'];
  }

  // Datumsauswahl generieren
  function GetDateSelect($day = 0, $month = 0, $year = 0, $suffix = '') {
    $output = array('d' => '', 'm' => '', 'y' => '');
    // Tage
    $output['d'] = '<select name="day' . $suffix . '"><option value="0">--</option>';
    for ($i = 1; $i <= 31; $i++) {
      $output['d'] .= '<option value="' . $i . '"' . ($i == $day ? ' selected="selected"' : '') . '>' . sprintf('%02d', $i) . '</option>';
    }
    $output['d'] .= '</select>';
    // Monate
    $output['m'] = '<select name="month' . $suffix . '"><option value="0">--</option>';
    for ($i = 1; $i <= 12; $i++) {
      $output['m'] .= '<option value="' . $i . '"' . ($i == $month ? ' selected="selected"' : '') . '>' . sprintf('%02d', $i) . '</option>';
    }
    $output['m'] .= '</select>';
    // Jahre
    $output['y'] = '<select name="year' . $suffix . '"><option value="0">----</option>';
    $current = date('Y');
    $start = $current - 4;
    for ($i = $current; $i >= $start; $i--) {
      $output['y'] .= '<option value="' . $i . '"' . ($i == $year ? ' selected="selected"' : '') . '>' . $i . '</option>';
    }
    $output['y'] .= '</select>';
    return $output;
  }
  
  // Versionsauswahl generieren
  function GetVersionSelect($name, $preselect) {
    $output = '<select name="' . $name . '">';
    $sql = 'SELECT version_id, version_text FROM ' . TABLE_VERSIONS . ' WHERE navitem_id=' . $_GET['tid'] . ' ORDER BY version_id DESC';
    $query = @mysql_query($sql);
    if (@mysql_num_rows($query) == 0) {
      $output .= '<option value="-1">---</option>';
    } else {
      while ($row = @mysql_fetch_array($query)) {
        $output .= '<option value="' . $row['version_id'] . '"' . ($row['version_id'] == $preselect ? ' selected="selected"' : '') . '>' . $row['version_text'] . '</option>';
      }
    }
    $output .= '</select>';
    return $output;
  }

  $sql = 'SELECT COUNT(navitem_id) AS NavitemCount FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['tid'] . ' AND navitem_type=' . NAVITEM_TODO;
  $query = @mysql_query($sql);
  $row = @mysql_fetch_array($query);
  if ($row['NavitemCount'] == 0) {
    ShowError(str_replace('%s', $_GET['tid'], $lang['todo_error']));
  } else {
    // Rechte prfen
    if (!UserAuth($_SESSION['ptodo_user_id'], $_GET['tid'], AUTH_VIEW)) {
      ShowError($lang['auth_todo_error']);
    } else {
      if ($_GET['action'] == 'add') { // Eintrag einfgen
        // Rechte prfen
        if (!UserAuth($_SESSION['ptodo_user_id'], $_GET['tid'], AUTH_ADD)) {
          ShowError($lang['auth_todo_add_error']);
        } else {
          if (isset($_POST['send']) && !empty($_POST['title']) && !empty($_POST['desc'])) {
            $dev = (isset($_POST['self']) && UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ISDEV) ? $_SESSION['ptodo_user_id'] : 0);
            $sql = 'INSERT INTO ' . TABLE_ITEMS . ' (navitem_id, item_author, item_title, item_priority, item_type, item_text, item_starttime, item_endtime, item_done, developer_id) VALUES (' . $_GET['tid'] . ', ' . $_SESSION['ptodo_user_id'] . ', "' . $_POST['title'] . '", ' . $_POST['priority'] . ', ' . $_POST['type'] . ', "' . $_POST['desc'] . '", ' . time() . ', 0, 0, ' . $dev . ')';
            @mysql_query($sql);
            $sql = 'SELECT item_id FROM ' . TABLE_ITEMS . ' WHERE item_author=' . $_SESSION['ptodo_user_id'] . ' ORDER BY item_id DESC LIMIT 0, 1';
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
            if ($dev > 0) {
              AddHistoryItem($row['item_id'], HISTORY_SETDEV, $lang['set_add']);
            }
            header('location: ?id=' . $row['item_id'] . (isset($_POST['add_upload']) ? '&action=file_add' : ''));
          } else {
            if (isset($_POST['preview'])) {
?>
<b><?php echo $lang['preview']; ?>:</b><br />
<br />
<table cellpadding="2" cellspacing="0">
<tr><td><?php echo $lang['id']; ?>:&nbsp;</td><td>-</td></tr>
<tr><td><?php echo $lang['title']; ?>:&nbsp;</td><td><?php echo stripslashes($_POST['title']); ?></td></tr>
<tr><td><?php echo $lang['author']; ?>:&nbsp;</td><td class="td_dev_user"><?php echo GetUserName($_SESSION['ptodo_user_id']); ?></td></tr>
<tr><td><?php echo $lang['priority']; ?>:&nbsp;</td><td><?php echo $lang[GetPriorityName($_POST['priority'])]; ?></td></tr>
<tr><td><?php echo $lang['type']; ?>:&nbsp;</td><td><?php echo $lang[GetTypeName($_POST['type'])]; ?></td></tr>
<tr><td><?php echo $lang['item_added']; ?>:&nbsp;</td><td><?php echo date($lang['time_format'], time()); ?></td></tr>
<tr><td><?php echo $lang['item_completed']; ?>:&nbsp;</td><td><?php echo $lang['not_closed']; ?></td></tr>
<tr><td><?php echo $lang['developer']; ?>:&nbsp;</td><td><?php echo (isset($_POST['self']) ? '<span class="td_dev_user">' . GetUserName($_SESSION['ptodo_user_id']) . '</span>' : $lang['no_developer']); ?></td></tr>
<tr><td valign="top"><?php echo $lang['description']; ?>:&nbsp;</td><td><?php echo ParseBBCode(HtmlEnt(stripslashes($_POST['desc']))); ?><br /><br /></td></tr>
</table>
<br />
<?php
            }
            $title_error = $desc_error = '';
            if (isset($_POST['send'])) {
              if (empty($_POST['title'])) {
                $title_error = ' <span class="info_warning">' . $lang['notice'] . ': ' . $lang['empty_title'] . '</span>';
              }
              if (empty($_POST['desc'])) {
                $desc_error = ' <span class="info_warning">' . $lang['notice'] . ': ' . $lang['empty_desc'] . '</span>';
              }
            }
?>
<form action="?tid=<?php echo $_GET['tid']; ?>&amp;action=add" method="post">
<b><?php echo GetTitle() . ' - ' . $lang['add_new_item']; ?></b><br />
<br />
<?php echo $lang['title'] . ':' . $title_error; ?><br />
<input type="text" name="title" class="input_text" value="<?php echo HtmlEnt(isset($_POST['title']) ? stripslashes($_POST['title']) : ''); ?>" /><br />
<br />
<?php echo $lang['description'] . ':' . $desc_error; ?><br />
<?php echo GetBBCodePanel('ta_todo_add'); ?><br />
<textarea name="desc" class="textarea_todo_add" id="ta_todo_add"><?php echo HtmlEnt(isset($_POST['desc']) ? stripslashes($_POST['desc']) : ''); ?></textarea><br />
<br />
<?php echo $lang['priority'] . ': ' . GetPrioritySelect(isset($_POST['priority']) ? $_POST['priority'] : PRIORITY_NORMAL) . '&nbsp;&nbsp;&nbsp;' . $lang['type'] . ': ' . GetTypeSelect(isset($_POST['type']) ? $_POST['type'] : TYPE_OTHER); ?><br />
<br />
<?php
            if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ISDEV)) {
?>
<fieldset><legend><?php echo $lang['options']; ?>:</legend>
<input type="checkbox" name="self" style="vertical-align:middle"<?php echo (isset($_POST['self']) ? ' checked="checked"' : '') . '/> ' . $lang['self_set']; ?><br />
<?php
            }
            if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD_DOWNLOAD)) {
?>
<input type="checkbox" name="add_upload" style="vertical-align:middle"<?php echo (isset($_POST['add_upload']) ? ' checked="checked"' : '') . '/> ' . $lang['add_upload']; ?><br />
<?php
            }
?>
</fieldset>
<br />
<input type="submit" accesskey="s" name="send" value="<?php echo $lang['add']; ?>" /> <input type="submit" name="preview" value="<?php echo $lang['preview']; ?>" />
</form>
<?php
          }
        }
      } elseif ($_GET['action'] == 'search') { // Suche anzeigen
        if (!empty($_GET['search'])) {
          echo '<b>' . GetTitle() . ' - ' . $lang['search_result'] . '</b><br />';
          $item_status = array(STATUS_OPEN, STATUS_CLOSE, STATUS_DONE);
          for ($i = 0; $i < count($item_status); $i++) {
            $item_data = GetItemDataByStatus($item_status[$i]);
            $search_key = str_replace('*', '%', $_GET['search']);
            switch ($_GET['place']) {
              case SEARCH_TITLE: $sql_search = 'item_title LIKE "%s"'; break;
              case SEARCH_TEXT: $sql_search = 'item_text LIKE "%s"'; break;
              case SEARCH_TITLETEXT: $sql_search = '(item_title LIKE "%s" OR item_text LIKE "%s")'; break;
            }
            $sql_search = str_replace('%s', '%' . $search_key . '%', $sql_search);
            $sql = 'SELECT item_id, item_title, item_priority, item_type, developer_id FROM ' . TABLE_ITEMS . ' WHERE navitem_id=' . $_GET['tid'] . ' AND ' . $item_data['sql_where'] . ' AND ' . $sql_search . ' ORDER BY item_id DESC';
            $query = @mysql_query($sql);
            $count = @mysql_num_rows($query);
            echo '<br /><div class="div_index_' . $item_data['style'] . '"><span class="span_index_title">' . $item_data['title'] . ' ' . $lang['items'] . ' (' . $lang['entire'] . ': ' . $count . '):</span></div><br />';
            if ($count == 0) {
              echo $lang['no_items'] . '<br /><br />';
            } else {
              // Eintrge anzeigen
              echo '<table cellpadding="2" cellspacing="0">';
              echo '<tr><td>#</td><td>' . $lang['type'] . '</td><td>' . $lang['developer'] . '</td><td>' . $lang['title'] . '</td></tr>';
              while ($row = @mysql_fetch_array($query)) {
                if ($row['developer_id'] == 0) {
                  $dev_class = '_nodev';
                  $dev_name = '---';
                } else {
                  $dev_class = ($row['developer_id'] == $_SESSION['ptodo_user_id'] ? '_user' : '');
                  $dev_name = GetUserName($row['developer_id']);
                }
                $title = HtmlEnt($row['item_title']);
                if ($_GET['place'] == SEARCH_TITLE || $_GET['place'] == SEARCH_TITLETEXT) {
                  $title = HighlightSearchString($_GET['search'], $title);
                }
                echo '<tr><td class="priority_' . GetPriorityName($row['item_priority']) . '">' . $row['item_id'] . '</td><td class="td_aligncenter">' . GetShortTypeName($row['item_type']) . '</td><td class="td_dev' . $dev_class . '">' . $dev_name . '</td><td><a href="?id=' . $row['item_id'] . '&amp;search=' . urlencode($_GET['search']) . '&amp;place=' . (int)$_GET['place'] . '">' . $title . '</a></td></tr>';
              }
              echo '</table><br />';
            }
          }
        } else {
          echo '<b>' . GetTitle() . ' - ' . $lang['search'] . '</b><br />';
?>
<br />
<form action="?" method="get">
<input type="hidden" name="tid" value="<?php echo $_GET['tid']; ?>" />
<input type="hidden" name="action" value="search" />
<table>
<tr><td><?php echo $lang['search_word']; ?>*:</td><td><input type="text" name="search" /></td></tr>
<tr><td><?php echo $lang['search_place']; ?>:</td><td><select name="place">
<?php echo '<option value="' . SEARCH_TITLE . '">' . $lang['title']; ?></option>
<?php echo '<option value="' . SEARCH_TEXT . '">' . $lang['description']; ?></option>
<?php echo '<option value="' . SEARCH_TITLETEXT . '">' . $lang['title'] . ' &amp; ' . $lang['description']; ?></option>
</select></td></tr>
<tr><td colspan="2" style="text-align:center"><br /><input type="submit" accesskey="s" value="<?php echo $lang['search']; ?>" /></td></tr>
</table>
* <?php echo $lang['search_info']; ?>
</form>
<?php
        }
      } elseif ($_GET['action'] == 'list') { // Eintrge einer Sektion anzeigen
        $item_data = GetItemDataByStatus($_GET['type']);
        $sql = 'SELECT COUNT(item_id) AS ItemsCount FROM ' . TABLE_ITEMS . ' WHERE navitem_id=' . $_GET['tid'] . ' AND ' . $item_data['sql_where'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $count = $row['ItemsCount'];
        echo '<div class="div_index_' . $item_data['style'] . '"><span class="span_index_title">' . $item_data['title'] . ' ' . $lang['items'] . ' (' . $lang['entire'] . ': ' . $count . '):</span></div><br />';
        if ($count == 0) {
          echo $lang['no_items'] . '<br />';
        } else {
          // Seitenlinks generieren
          $pages = ceil($count / $cfg['items_per_page']);
          if (empty($_GET['start'])) {
            $_GET['start'] = 0;
          }
          $page_links = $lang['page'] . ($pages > 1 ? 'n' : '') . ': ';
          for ($i = 0; $i < $pages; $i++) {
            if ($i * $cfg['items_per_page'] == $_GET['start']) {
              $page_links .= ' <b>' . ($i + 1) . '</b> ';
            } else {
              $page_links .= ' <a href="?tid=' . $_GET['tid'] . '&amp;action=list&amp;type=' . (int)$_GET['type'] . '&amp;start=' . ($i * $cfg['items_per_page']) . '">' . ($i + 1) . '</a> ';
            }
          }
          if (empty($_GET['sort'])) {
            $_GET['sort'] = SORT_ID;
          }
          if (empty($_GET['sort_order'])) {
            $_GET['sort_order'] = SORT_ORDER_DESC;
          }
          echo '<form action="?" method="get" class="no_print"><input type="hidden" name="tid" value="' . $_GET['tid'] . '" /><input type="hidden" name="action" value="list" /><input type="hidden" name="type" value="' . (int)$_GET['type'] . '" />' . $lang['sort'] . ': <select name="sort"><option value="' . SORT_ID . '"' . ($_GET['sort'] == SORT_ID ? ' selected="selected"' : '') . '>' . $lang['id'] . ' / ' . $lang['date'] . '</option>' . ($_GET['type'] == STATUS_OPEN ? '' : '<option value="' . SORT_ENDDATE . '"' . ($_GET['sort'] == SORT_ENDDATE ? ' selected="selected"' : '') . '>' . $lang['enddate'] . '</option>') . '<option value="' . SORT_PRIORITY . '"' . ($_GET['sort'] == SORT_PRIORITY ? ' selected="selected"' : '') . '>' . $lang['priority'] . '</option><option value="' . SORT_TITLE . '"' . ($_GET['sort'] == SORT_TITLE ? ' selected="selected"' : '') . '>' . $lang['title'] . '</option><option value="' . SORT_TYPE . '"' . ($_GET['sort'] == SORT_TYPE ? ' selected="selected"' : '') . '>' . $lang['type'] . '</option></select><select name="sort_order"><option value="' . SORT_ORDER_DESC . '"' . ($_GET['sort_order'] == SORT_ORDER_DESC ? ' selected="selected"' : '') . '>' . $lang['sort_desc'] . '</option><option value="' . SORT_ORDER_ASC . '"' . ($_GET['sort_order'] == SORT_ORDER_ASC ? ' selected="selected"' : '') . '>' . $lang['sort_asc'] . '</option></select><input type="submit" value="' . $lang['go'] . '" /></form><br />';
          echo $page_links . '<br /><br />';
          // Eintrge anzeigen
          echo '<table cellpadding="2" cellspacing="0">';
          echo '<tr><td>#</td><td>' . $lang['type'] . '</td><td>' . $lang['developer'] . '</td><td>' . $lang['title'] . '</td></tr>';
          switch ($_GET['sort']) {
            case SORT_ENDDATE: $order_by = 'item_endtime'; break;
            case SORT_PRIORITY: $order_by = 'item_priority'; break;
            case SORT_TITLE: $order_by = 'item_title'; break;
            case SORT_TYPE: $order_by = 'item_type'; break;
            default: $order_by = 'item_id';
          }
          switch ($_GET['sort_order']) {
            case SORT_ORDER_ASC: $order_by .= ' ASC'; break;
            default: $order_by .= ' DESC';
          }
          $sql = 'SELECT item_id, item_title, item_priority, item_type, developer_id FROM ' . TABLE_ITEMS . ' WHERE navitem_id=' . $_GET['tid'] . ' AND ' . $item_data['sql_where'] . ' ORDER BY ' . $order_by . ' LIMIT ' . (int)$_GET['start'] . ', ' . $cfg['items_per_page'];
          $query = @mysql_query($sql);
          while ($row = @mysql_fetch_array($query)) {
            if ($row['developer_id'] == 0) {
              $dev_class = '_nodev';
              $dev_name = '---';
            } else {
              $dev_class = ($row['developer_id'] == $_SESSION['ptodo_user_id'] ? '_user' : '');
              $dev_name = GetUserName($row['developer_id']);
            }
            echo '<tr><td class="priority_' . GetPriorityName($row['item_priority']) . '">' . $row['item_id'] . '</td><td class="td_aligncenter">' . GetShortTypeName($row['item_type']) . '</td><td class="td_dev' . $dev_class . '">' . $dev_name . '</td><td><a href="?id=' . $row['item_id'] . '">' . HtmlEnt($row['item_title']) . '</a></td></tr>';
          }
          echo '</table><br />' . $page_links;
        }
      } elseif ($_GET['action'] == 'set_version') { // Neue Version setzen
        // Rechte prfen
        if (!UserIsAdmin($_SESSION['ptodo_user_id'])) {
          header('location: ?tid=' . $_GET['tid']);
          die;
        } else {
          $date_error = $date_last_error = false;
          if (!empty($_POST['version_no'])) {
            // Datum prfen
            if (($_POST['day'] == 0) || ($_POST['month'] == 0) || ($_POST['year'] == 0)) {
              $date = 0;
            } else {
              $date = -1;
              $date_error = !checkdate($_POST['month'], $_POST['day'], $_POST['year']);
            }
            // Datum der Vorversion prfen
            if (isset($_POST['set_last_version'])) {
              if (($_POST['day_last'] == 0) || ($_POST['month_last'] == 0) || ($_POST['year_last'] == 0)) {
                $date_last = 0;
              } else {
                $date_last = -1;
                $date_last_error = !checkdate($_POST['month_last'], $_POST['day_last'], $_POST['year_last']);
              }
            }
            if (!$date_error && !$date_last_error) {
              // Neue Version setzen
              if ($date == -1) {
                if (($_POST['day'] == date('j')) && ($_POST['month'] == date('n')) && ($_POST['year'] == date('Y'))) {
                  $hour = date('H');
                  $minute = date('i');
                  $second = date('s');
                } else {
                  $hour = $minute = $second = 0;
                }
                $date = mktime($hour, $minute, $second, $_POST['month'], $_POST['day'], $_POST['year']);
              }
              $sql = 'INSERT INTO ' . TABLE_VERSIONS . ' (version_time, navitem_id, version_text) VALUES (' . $date . ', ' . $_GET['tid'] . ', "' . $_POST['version_no'] . '")';
              @mysql_query($sql);
              // Datum der Vorversion setzen
              if (isset($_POST['set_last_version'])) {
                if (($_POST['day_last'] == date('j')) && ($_POST['month_last'] == date('n')) && ($_POST['year_last'] == date('Y'))) {
                  $hour = date('H');
                  $minute = date('i');
                  $second = date('s');
                } else {
                  $hour = $minute = $second = 0;
                }
                $date_last = mktime($hour, $minute, $second, $_POST['month_last'], $_POST['day_last'], $_POST['year_last']);
                $sql = 'UPDATE ' . TABLE_VERSIONS . ' SET version_time=' . $date_last . ' WHERE version_id=' . $_POST['old_id'];
                @mysql_query($sql);
              }
              header('location: ?tid=' . $_GET['tid']);
              die;
            }
          }
          echo '<b>' . GetTitle() . ' - ' . $lang['version_set'] . '</b><br /><br />';
          // Aktuelle Version auslesen
          $sql = 'SELECT version_id, version_text, version_time FROM ' . TABLE_VERSIONS . ' WHERE navitem_id=' . $_GET['tid'] . ' ORDER BY version_id DESC LIMIT 0, 1';
          $query = @mysql_query($sql);
          if (@mysql_num_rows($query) == 0) {
            $project_version = $lang['no_version'];
            $old_exists = false;
            $old_id = '';
          } else {
            $old_exists = true;
            $row = @mysql_fetch_array($query);
            $old_dateset = ($row['version_time'] > 0);
            $project_version = HtmlEnt($row['version_text']) . ' (' . ($old_dateset ? date($lang['date_format'], $row['version_time']) : '-') . ')';
            $old_id = '<input type="hidden" name="old_id" value="' . $row['version_id'] . '" />';
          }
          echo $lang['this_version'] . ': ' . $project_version . '<br /><br /><b>' . $lang['new_version'] . ':</b><br /><br />';
          echo '<form action="?tid=' . $_GET['tid'] . '&amp;action=set_version" method="post">' . $old_id . $lang['version_id'] . ': <input type="text" name="version_no" value="' . (isset($_POST['version_no']) ? stripslashes($_POST['version_no']) : '') . '" /><br /><br />';
          // Datumsauswahl
          $date_select = GetDateSelect((isset($_POST['day']) ? $_POST['day'] : 0), (isset($_POST['month']) ? $_POST['month'] : 0), (isset($_POST['year']) ? $_POST['year'] : 0));
          $search = array('%day', '%month', '%year');
          echo $lang['version_date'] . ': ' . str_replace($search, $date_select, $lang['date_select']) . ($date_error ? ' <span class="info_warning">' . $lang['invalid_date'] . '</span>' : '') . '<br /><br />';
          if ($old_exists) {
            $date_select = GetDateSelect((isset($_POST['day_last']) ? $_POST['day_last'] : date('j')), (isset($_POST['month_last']) ? $_POST['month_last'] : date('n')), (isset($_POST['year_last']) ? $_POST['year_last'] : date('Y')), '_last');
            echo '<fieldset><legend>'.$lang['options'] . ':</legend><input type="checkbox" name="set_last_version"' . ($old_dateset ? '' : ' checked="checked"') . ' /> ' . $lang['set_last_version'] . ': ' . str_replace($search, $date_select, $lang['date_select']) . '</fieldset><br />';
          }
          echo $lang['open_date_info'] . '<br /><br /><input type="submit" value="' . $lang['version_set'] . '" /></form>';
        }
      } elseif ($_GET['action'] == 'show_versions') { // Versionsbersicht anzeigen
        echo '<b>' . GetTitle() . ' - ' . $lang['version_overview'] . '</b><br /><br /><a href="?tid=' . $_GET['tid'] . '&amp;action=changelog">' . $lang['changelog_gen'] . '</a><br /><br />' . $lang['versions_exists'] . ':<br /><br />';
        // Versionen auflisten
        $sql = 'SELECT version_id, version_time, version_text FROM ' . TABLE_VERSIONS . ' WHERE navitem_id=' . $_GET['tid'] . ' ORDER BY version_id DESC';
        $query = @mysql_query($sql);
        if (@mysql_num_rows($query) == 0) {
          echo $lang['no_version'];
        } else {
          while ($row = @mysql_fetch_array($query)) {
            echo '<a href="?tid=' . $_GET['tid'] . '&amp;action=version_items&amp;version_id=' . $row['version_id'] . '">' . $row['version_text'] . '</a> (' . ($row['version_time'] == 0 ? '-' : date($lang['date_format'], $row['version_time'])) . (UserIsAdmin($_SESSION['ptodo_user_id']) ? ' | <a href="?tid=' . $_GET['tid'] . '&amp;action=edit_version&amp;version_id=' . $row['version_id'] . '">' . $lang['edit'] . '</a>' : '') .')<br />';
          }
        }
      } elseif ($_GET['action'] == 'edit_version') { // Version bearbeiten
        // Rechte prfen
        if (!UserIsAdmin($_SESSION['ptodo_user_id'])) {
          header('location: ?tid=' . $_GET['tid']);
          die;
        } else {
          // Versionsid prfen
          $sql = 'SELECT version_time, version_text FROM ' . TABLE_VERSIONS . ' WHERE version_id=' . (int)$_GET['version_id'];
          $query = @mysql_query($sql);
          if (@mysql_num_rows($query) == 0) {
            header('location: ?tid=' . $_GET['tid'] . '&action=show_versions');
          } else {
            $date_error = false;
            if (isset($_POST['version_no'])) {
              // Datum prfen
              if (($_POST['day'] == 0) || ($_POST['month'] == 0) || ($_POST['year'] == 0)) {
                $date = 0;
              } else {
                $date = -1;
                $date_error = !checkdate($_POST['month'], $_POST['day'], $_POST['year']);
              }
              if (!$date_error) {
                // Neue Version setzen
                if ($date == -1) {
                 if (($_POST['day'] == date('j')) && ($_POST['month'] == date('n')) && ($_POST['year'] == date('Y'))) {
                    $hour = date('H');
                    $minute = date('i');
                    $second = date('s');
                  } else {
                    $hour = $minute = $second = 0;
                  }
                  $date = mktime($hour, $minute, $second, $_POST['month'], $_POST['day'], $_POST['year']);
                }
                $sql = 'UPDATE ' . TABLE_VERSIONS . ' SET version_time=' . $date . ', version_text="' . $_POST['version_no'] . '" WHERE version_id=' . (int)$_GET['version_id'];
                @mysql_query($sql);
                header('location: ?tid=' . $_GET['tid'] . '&action=show_versions');
                die;
              }
            } else {
              $row = @mysql_fetch_array($query);
              $_POST['version_no'] = $row['version_text'];
              if ($row['version_time'] == 0) {
                $_POST['day'] = 0;
                $_POST['month'] = 0;
                $_POST['year'] = 0;
              } else {
                $_POST['day'] = date('j', $row['version_time']);
                $_POST['month'] = date('n', $row['version_time']);
                $_POST['year'] = date('Y', $row['version_time']);
              }
            }
            echo '<b>' . GetTitle() . ' - ' . $lang['version_edit'] . '</b><br /><br />';
            echo '<form action="?tid=' . $_GET['tid'] . '&amp;action=edit_version&amp;version_id=' . (int)$_GET['version_id'] . '" method="post">' . $lang['version_id'] . ': <input type="text" name="version_no" value="' . (isset($_POST['version_no']) ? stripslashes($_POST['version_no']) : '') . '" /><br /><br />';
            // Datumsauswahl
            $date_select = GetDateSelect($_POST['day'], $_POST['month'], $_POST['year']);
            $search = array('%day', '%month', '%year');
            echo $lang['version_date'] . ': ' . str_replace($search, $date_select, $lang['date_select']) . ($date_error ? ' <span class="info_warning">' . $lang['invalid_date'] . '</span>' : '') . '<br /><br />';
            echo $lang['open_date_info'] . '<br /><br /><input type="submit" value="' . $lang['version_edit'] . '" /></form>';
          }
        }
      } elseif ($_GET['action'] == 'version_items') { // Eintrge einer Version auflisten
        // Versionsid prfen
        $sql = 'SELECT version_time, version_text FROM ' . TABLE_VERSIONS . ' WHERE version_id<=' . (int)$_GET['version_id'] . ' ORDER BY version_id DESC LIMIT 0, 2';
        $query = @mysql_query($sql);
        $count = @mysql_num_rows($query);
        if ($count == 0) {
          header('location: ?tid=' . $_GET['tid'] . '&action=show_versions');
        } else {
          $row = @mysql_fetch_array($query);
          echo '<b>' . GetTitle() . ' - ' . $row['version_text'] . ' (' . ($row['version_time'] == 0 ? '-' : date($lang['date_format'], $row['version_time'])) . ')</b><br /><br />';
          $this_time = ($row['version_time'] == 0 ? time() : $row['version_time']);
          // Datum der Vorversion ermitteln
          if ($count == 2) {
            $row = @mysql_fetch_array($query);
            $last_time = ($row['version_time'] == 0 ? 1 : $row['version_time']);
          } else {
            $last_time = 1;
          }
          // Eintrge auslesen
          $sql = 'SELECT item_id, item_title, item_priority, item_type, developer_id FROM ' . TABLE_ITEMS . ' WHERE navitem_id=' . $_GET['tid'] . ' AND item_done=1 AND item_endtime>=' . $last_time . ' AND item_endtime<=' . $this_time . ' ORDER BY item_endtime DESC';
          $query = @mysql_query($sql);
          $count = @mysql_num_rows($query);
          echo '<div class="div_index_done"><span class="span_index_title">' .  $lang['version_items'] . ' (' . $lang['entire'] . ': ' . $count . '):</span></div><br />';
          if ($count == 0) {
            echo $lang['no_items'] . '<br />';
          } else {
            echo '<table cellpadding="2" cellspacing="0">';
            echo '<tr><td>#</td><td>' . $lang['type'] . '</td><td>' . $lang['developer'] . '</td><td>' . $lang['title'] . '</td></tr>';
            while ($row = @mysql_fetch_array($query)) {
              if ($row['developer_id'] == 0) {
                $dev_class = '_nodev';
                $dev_name = '---';
              } else {
                $dev_class = ($row['developer_id'] == $_SESSION['ptodo_user_id'] ? '_user' : '');
                $dev_name = GetUserName($row['developer_id']);
              }
              echo '<tr><td class="priority_' . GetPriorityName($row['item_priority']) . '">' . $row['item_id'] . '</td><td class="td_aligncenter">' . GetShortTypeName($row['item_type']) . '</td><td class="td_dev' . $dev_class . '">' . $dev_name . '</td><td><a href="?id=' . $row['item_id'] . '">' . HtmlEnt($row['item_title']) . '</a></td></tr>';
            }
            echo '</table>';
          }
        }
      } elseif ($_GET['action'] == 'changelog') { // Changelog Generator
        echo '<b>' . GetTitle() . ' - ' . $lang['changelog_gen'] . '</b><br /><br />';
        echo '<form action="?tid=' . $_GET['tid'] . '&amp;action=changelog" method="post">';
        echo '<fieldset><legend>Versionen:</legend>';
        // Versionen ermitteln
        $search = array('%start', '%end');
        $replace = array(
          GetVersionSelect('version_start', (isset($_POST['version_start']) ? $_POST['version_start'] : 0)),
          GetVersionSelect('version_end', (isset($_POST['version_end']) ? $_POST['version_end'] : 0))
        );
        echo str_replace($search, $replace, $lang['from_to']);
        $error = false;
        if (isset($_POST['send'])) {
          if ($_POST['version_start'] == -1 || $_POST['version_end'] == -1) {
            echo ' <span class="info_warning">' . $lang['version_select_error'] . '</span>';
            $error = true;
          } elseif ($_POST['version_start'] > $_POST['version_end']) {
            echo ' <span class="info_warning">' . $lang['version_sort_error'] . '</span>';
            $error = true;
          }
        }
        echo '</fieldset><br /><fieldset><legend>' . $lang['item_prefix'] . ':</legend>';
        echo '<table><tr><td style="text-align:right"><input type="checkbox" name="show_prefix"' . (isset($_POST['show_prefix']) ? ' checked="checked"' : '') . ' /></td><td>' . $lang['show_prefix'] . '</td></tr>';
        if (isset($_POST['send'])) {
          $other_value = stripslashes($_POST['prefix_other']);
          $feature_value = stripslashes($_POST['prefix_feature']);
          $bugfix_value = stripslashes($_POST['prefix_bugfix']);
        } else {
          $other_value = $cfg['type_prefix_other'];
          $feature_value = $cfg['type_prefix_feature'];
          $bugfix_value = $cfg['type_prefix_bugfix'];
        }
        echo '<tr><td>' . $lang['other'] . ':</td><td><input type="text" name="prefix_other" value="' . $other_value . '" /></td></tr>';
        echo '<tr><td>' . $lang['feature'] . ':</td><td><input type="text" name="prefix_feature" value="' . $feature_value . '" /></td></tr>';
        echo '<tr><td>' . $lang['bugfix'] . ':</td><td><input type="text" name="prefix_bugfix" value="' . $bugfix_value . '" /></td></tr>';
        echo '<tr><td style="text-align:right"><br /><input type="checkbox" name="show_date"' . (isset($_POST['show_date']) ? ' checked="checked"' :'') . ' /></td><td><br />' . $lang['show_versiondate'] . '</td></tr></table>';
        echo '</fieldset><br /><fieldset><legend>' . $lang['output'] . ':</legend>';
        $html_select = $txt_select = '';
        if (isset($_POST['output_type'])) {
          if ($_POST['output_type'] == 'html') {
            $html_select = ' selected="selected"';
          } elseif ($_POST['output_type'] == 'txt') {
            $txt_select = ' selected="selected"';
          }
        }
        $code_checked = (isset($_POST['output_code']) ? ' checked="checked"' : '');
        $sort_checked = (isset($_POST['output_sort']) ? ' checked="checked"' : '');
        echo $lang['type'] . ': <select name="output_type"><option value="html"' . $html_select . '>' . $lang['html'] . '</option><option value="txt"' . $txt_select . '>' . $lang['text'] . '</option></select> <input type="checkbox" name="output_code"' . $code_checked . ' /> ' . $lang['show_code'] . ' <input type="checkbox" name="output_sort"' . $sort_checked . ' /> ' . $lang['sort_output'] . '<br /><br /><input type="submit" name="send" value="' . $lang['changelog_gen'] . '" />';
        echo '</fieldset>';
        echo '</form>';
        if (isset($_POST['send']) && !$error) {
          // Changelog erzeugen
          $html = ($_POST['output_type'] == 'html');
          $log = ($html ? '<ul>' . "\n" : '');
          $sql = 'SELECT version_id, version_time, version_text FROM ' . TABLE_VERSIONS . ' WHERE version_id>=' . $_POST['version_start'] . ' AND version_id<=' . $_POST['version_end'] . ' AND navitem_id=' . $_GET['tid'] . ' ORDER BY version_id DESC';
          $query = @mysql_query($sql);
          while ($row = @mysql_fetch_array($query)) {
            if ($html) {
              $log .= "  <li>\n    " . HtmlEnt($row['version_text']);
            } else {
              if (!empty($log)) {
                  $log .= "\n";
              }
              $log .= $lang['version'] . ' ' . $row['version_text'];
            }
            if (isset($_POST['show_date'])) {
              $log .= ' [' . ($row['version_time'] == 0 ? '-' : date($lang['date_format'], $row['version_time'])) . ']';
            }
            $log .= ':' . "\n";
            $this_time = ($row['version_time'] == 0 ? time() : $row['version_time']);
            // Datum der Vorversion ermitteln
            $sql_2 = 'SELECT version_time FROM ' . TABLE_VERSIONS . ' WHERE version_id<' . $row['version_id'] . ' AND navitem_id=' . $_GET['tid'] . ' ORDER BY version_id DESC LIMIT 0, 1';
            $query_2 = @mysql_query($sql_2);
            if (@mysql_num_rows($query_2)) {
              $row_2 = @mysql_fetch_array($query_2);
              $last_time = ($row_2['version_time'] == 0 ? 1 : $row_2['version_time']);
            } else {
              $last_time = 1;
            }
            // Eintrge auslesen
            $order_by = ($_POST['output_sort'] ? 'item_title' : 'item_endtime DESC');
            $sql_2 = 'SELECT item_title, item_type FROM ' . TABLE_ITEMS . ' WHERE navitem_id=' . $_GET['tid'] . ' AND item_done=1 AND item_endtime>=' . $last_time . ' AND item_endtime<=' . $this_time . ' ORDER BY ' . $order_by;
            $query_2 = @mysql_query($sql_2);
            $count = @mysql_num_rows($query_2);
            $c = 0;
            if ($count > 0) {
              if ($html) {
                $log .= '    <ul>' . "\n";
              }
              while ($row_2 = @mysql_fetch_array($query_2)) {
                if (isset($_POST['show_prefix'])) {
                  $prefix = $_POST['prefix_' . GetTypeName($row_2['item_type'], false)] . ' ';
                } else {
                  $prefix = '';
                }
                $log .= ($html ? '      <li>' . HtmlEnt($prefix . $row_2['item_title']) . (++$c == $count ? '<br /><br />' : '') . '</li>' : ' * ' . $prefix . $row_2['item_title']) . "\n";
              }
              if ($html) {
                $log .= '    </ul>' . "\n";
              }
            }
            if ($html) {
              $log .= '  </li>' . "\n";
            }
          }
          if ($html) {
            $log .= '</ul>';
          }
          if (isset($_POST['output_code'])) {
            echo '<br /><fieldset><legend>' . $lang['code'] . ':</legend><textarea class="textarea_todo_add">' . htmlspecialchars($log) . '</textarea></fieldset>';
          }
          if (!$html) {
            $log = '<pre>' . HtmlEnt($log) . '</pre>';
          }
          echo '<br /><fieldset><legend>' . $lang['changelog'] . ':</legend>' . $log . '</fieldset>';
        }
      } else { // bersicht anzeigen
        echo '<b>' . GetTitle() . ' - ' . $lang['overview'] . '</b><br /><br />';
        // Projektstatus ermitteln
        $sql = 'SELECT COUNT(item_id) AS ItemCount FROM ' . TABLE_ITEMS . ' WHERE item_endtime=0 AND item_done=0 AND navitem_id=' . $_GET['tid'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $items_open = $row['ItemCount'];
        $sql = 'SELECT COUNT(item_id) AS ItemCount FROM ' . TABLE_ITEMS . ' WHERE item_endtime>0 AND item_done=0 AND navitem_id=' . $_GET['tid'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $items_close = $row['ItemCount'];
        $sql = 'SELECT COUNT(item_id) AS ItemCount FROM ' . TABLE_ITEMS . ' WHERE item_endtime>0 AND item_done=1 AND navitem_id=' . $_GET['tid'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $items_done = $row['ItemCount'];
        $items_count = $items_open + $items_close + $items_done;
        if ($items_count == 0) {
          $statusbar = $lang['status_no_items'] . '<br />';
        } else {
          // Verteilung berechnen
          $bar_width = 150;
          $percent_point = 100 / $items_count;
          $red_percent = round($percent_point * $items_open);
          $yellow_percent = round($percent_point * $items_close);
          $green_percent = round($percent_point * $items_done);
          $percent_width = $bar_width / 100;
          $red_width = round($percent_width * $red_percent);
          $yellow_width = round($percent_width * $yellow_percent);
          $green_width = round($percent_width * $green_percent);
          $statusbar = '<table class="table_statusbar" cellpadding="0" cellspacing="0"><tr><td>' . $lang['status'] . ':&nbsp;</td><td class="td_status_open" style="font-size:1px;width:' . $red_width . 'px" title="' . $lang['status_open'] . ': ' . $red_percent . '%"></td><td class="td_status_close" style="width:' . $yellow_width . 'px" title="' . $lang['status_close'] . ': ' . $yellow_percent . '%"></td><td class="td_status_done" style="width:' . $green_width . 'px" title="' . $lang['status_done'] . ': ' . $green_percent . '%"></td><td class="td_print_status" style="border-left-width:' . ($red_width + $yellow_width) . 'px;width:' . $green_width . 'px"></td><td>&nbsp;' . $green_percent . '% ' . $lang['status_complete'] . '</td></tr></table>';
        }
        // Projektversion ermitteln
        $sql = 'SELECT version_text FROM ' . TABLE_VERSIONS . ' WHERE navitem_id=' . $_GET['tid'] . ' ORDER BY version_id DESC LIMIT 0, 1';
        $query = @mysql_query($sql);
        if (@mysql_num_rows($query) == 0) {
          $project_version = $lang['no_version'];
          $version_admin = '';
        } else {
          $row = @mysql_fetch_array($query);
          $project_version = HtmlEnt($row['version_text']);
          $version_admin = '<a href="?tid=' . $_GET['tid'] . '&amp;action=show_versions">' . $lang['version_overview'] . '</a>';
        }
        if (UserIsAdmin($_SESSION['ptodo_user_id'])) {
          if (!empty($version_admin)) {
            $version_admin .= ' | ';
          }
          $version_admin .= '<a href="?tid=' . $_GET['tid'] . '&amp;action=set_version">' . $lang['version_set'] . '</a>';
        }
        if (!empty($version_admin)) {
          $version_admin = ' (' . $version_admin . ')';
        }
        
        echo $statusbar . '<br />' . $lang['project_version'] . ': ' . $project_version . $version_admin . '<br />';

        // Die letzten Eintrge anzeigen
        function GetLastItems($status, $count_all) {
          global $cfg, $lang;
          $item_data = GetItemDataByStatus($status);
          switch ($status) {
            case STATUS_OPEN: $title = $lang['last_open']; break;
            case STATUS_CLOSE: $title = $lang['last_close']; break;
            case STATUS_DONE: $title = $lang['last_done']; break;
          }
          $sql = 'SELECT item_id, item_title, item_priority, item_type, developer_id FROM ' . TABLE_ITEMS . ' WHERE navitem_id=' . $_GET['tid'] . ' AND ' . $item_data['sql_where'] . ' ORDER BY item_' . ($status == STATUS_OPEN ? 'start' : 'end') . 'time DESC LIMIT 0, ' . $cfg['lastitems_count'];
          $query = @mysql_query($sql);
          $count = @mysql_num_rows($query);
          echo '<br /><br /><div class="div_index_' . $item_data['style'] . '"><span class="span_index_title">' . str_replace('%s', $cfg['lastitems_count'], $lang['last_items']) . ' ' . $title . ' ' . $lang['items'] . ' (' . $lang['entire'] . ': ' . $count_all . '):</span></div><br />';
          if ($count == 0) {
            echo $lang['no_items'] . '<br />';
          } else {
            echo '<table cellpadding="2" cellspacing="0">';
            echo '<tr><td>#</td><td>' . $lang['type'] . '</td><td>' . $lang['developer'] . '</td><td>' . $lang['title'] . '</td></tr>';
            while ($row = @mysql_fetch_array($query)) {
              if ($row['developer_id'] == 0) {
                $dev_class = '_nodev';
                $dev_name = '---';
              } else {
                $dev_class = ($row['developer_id'] == $_SESSION['ptodo_user_id'] ? '_user' : '');
                $dev_name = GetUserName($row['developer_id']);
              }
              echo '<tr><td class="priority_' . GetPriorityName($row['item_priority']) . '">' . $row['item_id'] . '</td><td class="td_aligncenter">' . GetShortTypeName($row['item_type']) . '</td><td class="td_dev' . $dev_class . '">' . $dev_name . '</td><td><a href="?id=' . $row['item_id'] . '">' . HtmlEnt($row['item_title']) . '</a></td></tr>';
            }
            echo '</table>';
            if ($count_all > $cfg['lastitems_count']) {
              echo '<br /><a href="?tid=' . $_GET['tid'] . '&amp;action=list&amp;type=' . $status . '">' . str_replace('%s', $count_all, $lang['show_all']) . '</a><br />';
            }
          }
        }
        // Die letzten offenen Eintrge anzeigen
        GetLastItems(STATUS_OPEN, $items_open);
        // Die letzten geschlossenen Eintrge anzeigen
        GetLastItems(STATUS_CLOSE, $items_close);
        // Die letzten abgenommenen Eintrge anzeigen
        GetLastItems(STATUS_DONE, $items_done);
      }
    }
  }
?>