<?php
/*-----------------------------------------------------------------------------
  pToDo
  -----
  ToDo Liste fr mehrere Projekte auf Basis von PHP und MySQL
  -----------------------------------------------------------
  Lizenz:

    Copyright (C) 2005 - 2006 Andreas "Pr0g" Droesch

    pToDo ist Freeware und darf ausdrcklich weitergegeben werden, sofern
    dies kostenlos und in unvernderter Form des Scripts geschieht.

    Der Autor haftet nicht fr Schden, die durch die Nutzung dieses Scripts
    entstanden sind!
  -----------------------------------------------------------------------------
  Author:

    Andreas "Pr0g" Droesch
    http://pr0g.net,
    webmaster@pr0g.net
    All Rights reserved.

  Version:
    27.07.2006 Pr0g v2.1.6
    17.06.2006 Pr0g v2.1.5
    04.06.2006 Pr0g v2.1.4
    17.04.2006 Pr0g v2.1.3
    12.04.2006 Pr0g v2.1.2
    10.04.2006 Pr0g v2.1.1
    09.04.2006 Pr0g v2.1
    19.03.2006 Pr0g v2.0
    12.03.2006 Pr0g v1.9
    10.03.2006 Pr0g v1.8
    05.03.2006 Pr0g v1.7
    25.02.2006 Pr0g v1.6
    19.02.2006 Pr0g v1.5
    03.02.2006 Pr0g v1.4
    22.01.2006 Pr0g v1.3
    13.12.2005 Pr0g v1.2
    12.12.2005 Pr0g v1.1
    30.11.2005 Pr0g v1.0
    
    Changelog in der "readme.txt"!
-----------------------------------------------------------------------------*/

  // Ausgabe Puffern um zwischendurch noch mit den Sessions / Headern arbeiten zu knnen
  ob_start();

  // Scriptversion
  $version = '2.1.6';
  
  // Laden der Module ermglichen
  define('IN_PTODO', true);

  // Sessions starten
  session_start();
  
  // Konfiguration (DB Einstellungen) einbinden
  require('config.php');

  // Konstanten einbinden
  require('modules/constants.php');
  
  // Quotes setzen, wenn Magic Quotes deaktiviert ist
  if(!get_magic_quotes_gpc()) {
    if(is_array($_GET)) {
      while(list($key, $value) = each($_GET)) {
        $_GET[$key] = addslashes($value);
      }
      @reset($_GET);
    }
    if(is_array($_POST)) {
      while(list($key, $value) = each($_POST)) {
        $_POST[$key] = addslashes($value);
      }
      @reset($_POST);
    }
    if(is_array($_COOKIE)) {
      while(list($key, $value) = each($_COOKIE)) {
        $_COOKIE[$key] = addslashes($value);
      }
      @reset($_COOKIE);
    }
  }
  
  // Datenbankverbindung herstellen
  $connect = @mysql_connect($dbHost, $dbUser, $dbPass) or die($lang['db_connection_error']);
  $selectDB = @mysql_select_db($dbName, $connect) or die(str_replace('%s', $dbName, $lang['db_database_error']));
  unset($dbHost, $dbUser, $dbPass);
  
  // Konfiguration auslesen
  $sql = 'SELECT config_name, config_value FROM ' . TABLE_CONFIG;
  $query = @mysql_query($sql);
  $cfg = array();
  while ($row = @mysql_fetch_array($query)) {
    $cfg[$row['config_name']] = $row['config_value'];
  }
  if (!empty($cfg['fileupload_exts'])) {
    $cfg['fileupload_exts'] = explode(',', $cfg['fileupload_exts']);
  }

  // Sprachdatei einbinden
  require('lang_de.php');

  // Ermitteln ob der User ein Admin ist
  function UserIsAdmin($uid) {
    static $UserIsAdmin_List = array();
    if (!isset($UserIsAdmin_List[$uid])) {
      if ($uid == -1) {
        $UserIsAdmin_List[$uid] = false;
      } else {
        $sql = 'SELECT user_isadmin FROM ' . TABLE_USERS . ' WHERE user_id=' . $uid;
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $UserIsAdmin_List[$uid] = ($row['user_isadmin'] == 1);
      }
    }
    return $UserIsAdmin_List[$uid];
  }

  // Rechte des Users prfen
  function UserAuth($uid, $item_id, $auth) {
    static $UserAuth_Groups = array();
    static $UserAuth_List = array();
    // Adminrecht
    if (UserIsAdmin($uid)) {
      return true;
    }
    // Benutzergruppe ermitteln
    if (!isset($UserAuth_Groups[$uid])) {
      if ($uid == -1) {
        $UserAuth_Groups[$uid] = GROUP_GUESTS;
      } else {
        $sql = 'SELECT group_id FROM ' . TABLE_USERS . ' WHERE user_id=' . (int)$uid;
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $UserAuth_Groups[$uid] = $row['group_id'];
      }
    }
    // Gruppenrechte fr das bergebene Item ermitteln
    $ug = $UserAuth_Groups[$uid];
    if (!isset($UserAuth_List[$ug . '_' . $item_id])) {
      $sql = 'SELECT rights_auth FROM ' . TABLE_RIGHTS . ' WHERE navitem_id=' . (int)$item_id . ' AND group_id=' . $ug;
      $query = @mysql_query($sql);
      if (@mysql_num_rows($query) == 0) {
        $UserAuth_List[$ug . '_' . $item_id] = 0;
      } else {
        $row = @mysql_fetch_array($query);
        $UserAuth_List[$ug . '_' . $item_id] = $row['rights_auth'];
      }
    }
    return ($UserAuth_List[$ug . '_' . $item_id] & $auth);
  }

  // Benutzernamen ermitteln
  function GetUserName($uid) {
    global $lang;
    static $GetUserName_List = array();
    if (!isset($GetUserName_List[$uid])) {
      if ($uid == -1) {
        $GetUserName_List[$uid] = $lang['guest'];
      } else {
        $sql = 'SELECT user_name FROM ' . TABLE_USERS . ' WHERE user_id=' . $uid;
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $GetUserName_List[$uid] = $row['user_name'];
      }
    }
    return $GetUserName_List[$uid];
  }
  
  // Gngige Sonderzeichen umwandeln
  function HtmlEnt($text, $html_tags = true) {
    $s1 = array('&', '', '', '', '', '', '', '');
    $s2 = array('&amp;', '&Auml;', '&Ouml;', '&Uuml;', '&auml;', '&ouml;', '&uuml;', '&szlig;');
    if ($html_tags) {
      array_push($s1, '<', '>', '"');
      array_push($s2, '&lt;', '&gt;', '&quot;');
    }
    return str_replace($s1, $s2, $text);
  }
  
  // Einen Fehler ausgeben
  function ShowError($msg) {
    global $lang;
    echo '<b>' . $lang['error'] . ':</b> ' . $msg;
  }

  // Id Prefix eines Typs ermitteln
  function GetTypeIdPrefix($type) {
    switch ($type) {
      case NAVITEM_GROUP: return 'g';
      case NAVITEM_LINK: return 'l';
      case NAVITEM_HTML: return 'h';
      case NAVITEM_TODO: return 't';
      case NAVITEM_FORUM: return 'b';
    }
  }

  // Name einer Prioritt ermitteln
  function GetPriorityName($priority) {
    switch ($priority) {
      case PRIORITY_VERYLOW: return 'verylow';
      case PRIORITY_LOW: return 'low';
      case PRIORITY_NORMAL: return 'normal';
      case PRIORITY_HIGH: return 'high';
      case PRIORITY_VERYHIGH: return 'veryhigh';
    }
  }
  
  // Name eines Typs ermitteln
  function GetTypeName($type, $status_open = true, $short_name = false) {
    switch ($type) {
      case TYPE_OTHER: return 'other';
      case TYPE_FEATURE: return ($status_open ? 'featurerequest' : 'feature');
      case TYPE_BUGFIX: return ($status_open ? 'bugreport' : 'bugfix');
    }
  }
  
  // Kurzname eines Typs ermitteln
  function GetShortTypeName($type) {
    global $lang;
    switch ($type) {
      case TYPE_OTHER: return $lang['other_short'];
      case TYPE_FEATURE: return $lang['feature_short'];
      case TYPE_BUGFIX: return $lang['bug_short'];
    }
  }

  // Daten fr ein Item anhand des Status ermitteln
  function GetItemDataByStatus($status) {
    global $lang;
    switch ($status) {
      case STATUS_OPEN: return array(
          'sql_where' => 'item_endtime=0 AND item_done=0',
          'style' => 'open',
          'title' => $lang['open']
        );
      case STATUS_CLOSE: return array(
          'sql_where' => 'item_endtime>0 AND item_done=0',
          'style' => 'close',
          'title' => $lang['close']
        );
      case STATUS_DONE: return array(
          'sql_where' => 'item_endtime>0 AND item_done=1',
          'style' => 'done',
          'title' => $lang['done']
        );
      case STATUS_NODEV: return array(
          'sql_where' => 'developer_id=0',
          'style' => 'nodev',
          'title' => $lang['nodev']
        );
    }
  }

  // Selectbox der Prioritten erstellen
  function GetPrioritySelect($selected) {
    global $lang;
    $output = '<select name="priority">';
    for ($i = PRIORITY_VERYHIGH; $i >= PRIORITY_VERYLOW; $i--) {
      $priority_name = GetPriorityName($i);
      $output .= '<option class="priority_' . $priority_name . '" value="' . $i . '"' . ($i == $selected ? ' selected="selected"' : '') . '>' . $lang[$priority_name] . '</option>';
    }
    return $output . '</select>';
  }

  // Selectbox der Typen erstellen
  function GetTypeSelect($selected, $status_open = true) {
    global $lang;
    $output = '<select name="type">';
    for ($i = TYPE_OTHER; $i <= TYPE_BUGFIX; $i++) {
      $type_name = GetTypeName($i, $status_open);
      $output .= '<option value="' . $i . '"' . ($i == $selected ? ' selected="selected"' : '') . '>' . $lang[$type_name] . '</option>';
    }
    return $output . '</select>';
  }

  // Dateigre (Bytes) in eine passende Gre umwandeln
  function FormatFileSize($size) {
    $formats = array('B', 'KB', 'MB', 'GB');
    $index = 0;
    while ($size >= 1024 && $index < 3) {
      $size /= 1024;
      $index++;
    }
    return round($size, 2) . ' ' . $formats[$index];
  }

  // Ermittelt die History Aktion
  function GetHistoryAction($history_action, $history_text, $decode_text = true) {
    global $lang;
    $history = array();
    switch ($history_action) {
      case HISTORY_EDIT: $action = $lang['history_edit']; break;
      case HISTORY_CLOSE: $action = $lang['history_close']; break;
      case HISTORY_OPEN: $action = $lang['history_open']; break;
      case HISTORY_DONE: $action = $lang['history_done']; break;
      case HISTORY_SETDEV: $action = $lang['history_setdev']; break;
      case HISTORY_UNSETDEV: $action = $lang['history_unsetdev']; break;
      case HISTORY_COMMENT: $action = $lang['history_comment']; break;
      case HISTORY_FILEADD:
        $action = $lang['history_fileadd'];
        $history['text'] = str_replace('%s', $history_text, $lang['history_fileadd_text']);
        break;
      case HISTORY_FILEDELETE:
        $action = $lang['history_filedelete'];
        $history['text'] = str_replace('%s', $history_text, $lang['history_filedelete_text']);
        break;
      case HISTORY_DEPENDENCEADD:
        $action = $lang['history_dependenceadd'];
        $history['text'] = str_replace('%s', $history_text, $lang['history_dependenceadd_text']);
        break;
      case HISTORY_DEPENDENCEDELETE:
        $action = $lang['history_dependencedelete'];
        $history['text'] = str_replace('%s', $history_text, $lang['history_dependencedelete_text']);
        break;
    }
    if (!isset($history['text'])) {
      $history['text'] = $history_text;
    }
    $history['action'] = $action;
    if ($decode_text) {
      $history['text'] = nl2br(ParseBBCode(str_replace('  ', '&nbsp;&nbsp;', HtmlEnt($history['text']))));
    }
    return $history;
  }

  // Einen Eintrag in die History einfgen
  function AddHistoryItem($item_id, $history_action, $history_text) {
    global $lang, $cfg;
    $history_time = time();
    $user_id = (int)$_SESSION['ptodo_user_id'];
    $sql = 'INSERT INTO ' . TABLE_HISTORY . ' (item_id, developer_id, history_action, history_time, history_text) VALUES (' . (int)$item_id . ', ' . $user_id . ', ' . $history_action . ', ' . $history_time . ', "' . $history_text . '")';
    @mysql_query($sql);
    // User benachtichtigen, die den Eintrag abonniert haben
    if (!empty($cfg['admin_email'])) {
      $sql = 'SELECT user_id FROM ' . TABLE_ITEMWATCH . ' WHERE item_id=' . (int)$item_id . ' AND user_id!=' . $user_id;
      $query = @mysql_query($sql);
      if (@mysql_num_rows($query) > 0) {
        $sql_2 = 'SELECT navitem_id, item_title FROM ' . TABLE_ITEMS . ' WHERE item_id=' . (int)$item_id;
        $query_2 = @mysql_query($sql_2);
        $row_2 = @mysql_fetch_array($query_2);
        $history = GetHistoryAction($history_action, $history_text, false);
        $search = array('%host', '%id', '%title', '%time', '%action', '%comment', '%link');
        $replace = array(
          $_SERVER['HTTP_HOST'],
          $item_id,
          $row_2['item_title'],
          date($lang['time_format'], $history_time),
          str_replace('%s', GetUserName($user_id), $history['action']),
          $history['text'],
          $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . '?id=' . (int)$item_id
        );
        $navitem_id = $row_2['navitem_id'];
        $email = str_replace($search, $replace, $lang['email_notify_text']);
        while ($row = @mysql_fetch_array($query)) {
          if (UserAuth($row['user_id'], $navitem_id, AUTH_HISTORY)) {
            $sql_2 = 'SELECT user_email FROM ' . TABLE_USERS . ' WHERE user_id=' . $row['user_id'] . ' AND user_email!=""';
            $query_2 = @mysql_query($sql_2);
            $row_2 = @mysql_fetch_array($query_2);
            mail($row_2['user_email'], $lang['email_notify_subject'], $email, 'From: ' . $cfg['admin_email']);
          }
        }
      }
    }
  }

  // Leere Variablen fllen
  $vars = array('section', 'sub', 'action');
  foreach ($vars as $var) {
    if (!isset($_GET[$var])) {
      $_GET[$var] = '';
    }
  }

  if (stristr($_SERVER['HTTP_ACCEPT'], 'application/xhtml+xml')) {
    header('Content-type: application/xhtml+xml;charset=iso-8859-1');
  } else {
    header('Content-type: text/html;charset=iso-8859-1');
  }

  // Suchtexte in einem String hervorheben
  function HighlightSearchString($search, $text) {
    $highlight_match = '';
    foreach (explode(' ', trim($search)) as $word) {
      if (trim($word)) {
        $highlight_match .= (($highlight_match != '') ? '|' : '') . str_replace('\*', '\w*?', preg_quote($word, '#'));
      }
    }
    if (($highlight_match === '') || ($text === '')) {
      return $text;
    }
    return preg_replace('#(?!<.*)(?<!\w)(' . $highlight_match . ')(?!\w|[^<>]*>)#i', '<span class="span_highlight">\1</span>', $text);
  }
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de">
<head>
<title>pToDo - <?php echo HtmlEnt($cfg['site_title'], false); ?></title>
<?php
  if (isset($_GET['redirect_fid'])) {
    echo '<meta http-equiv="refresh" content="0; url=?fid=' . (int)$_GET['redirect_fid'] . '" />';
  }
?>
<link rel="stylesheet" type="text/css" href="screen.css" media="screen" />
<style type="text/css">
#div_navi {
  width: <?php echo $cfg['navibox_width']; ?>px;
}

#div_headnavi, #div_content {
  margin-left: <?php echo ($cfg['navibox_width'] + 17); ?>px;
}

#div_navi a, #div_active_navi {
  width: <?php echo ($cfg['navibox_width'] - 8); ?>px;
}

#div_active_navi a {
  width: <?php echo ($cfg['navibox_width'] - 16); ?>px;
}
</style>
<link rel="stylesheet" type="text/css" href="print.css" media="print" />
</head>
<body>
<?php
  // User ausloggen
  if (isset($_GET['logout']) && isset($_SESSION['ptodo_user_id'])) {
    if ($_SESSION['ptodo_user_id'] > -1) {
      $sql = 'UPDATE ' . TABLE_USERS . ' SET user_loginkey="" WHERE user_id=' . (int)$_SESSION['ptodo_user_id'];
      @mysql_query($sql);
      setcookie('ptodo_login_id', -1, time() - 3600); // Cookies auslaufen lassen
      setcookie('ptodo_login_key', '', time() - 3600);
      unset($_COOKIE['ptodo_login_id'], $_COOKIE['ptodo_login_key']);
      unset($_SESSION['ptodo_user_logged'], $_SESSION['ptodo_user_id']);
      header('location: ?');
    }
  }

  // Prfen, ob der User eingeloggt ist
  if (isset($_SESSION['ptodo_user_logged']) && isset($_SESSION['ptodo_user_id']) && !($_SESSION['ptodo_user_id'] == -1 && isset($_GET['login']))) {
    if (isset($_GET['fid'])) { // Datei herunterladen
      // Navitem Id des Downloads ermitteln
      $sql = 'SELECT item_id FROM ' . TABLE_FILES . ' WHERE file_id=' . (int)$_GET['fid'];
      $query = @mysql_query($sql);
      $row = @mysql_fetch_array($query);
      $sql = 'SELECT navitem_id FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $row['item_id'];
      $query = @mysql_query($sql);
      $row = @mysql_fetch_array($query);
      if ($_SESSION['ptodo_user_id'] == -1 && !UserAuth(-1, $row['navitem_id'], AUTH_VIEW_DOWNLOAD)) {
        header('location: ?login=1&fid=' . (int)$_GET['fid']);
        die;
      }
      if (UserAuth($_SESSION['ptodo_user_id'], $row['navitem_id'], AUTH_VIEW_DOWNLOAD)) {
        $sql = 'SELECT file_name, file_prefix FROM ' . TABLE_FILES . ' WHERE file_id=' . (int)$_GET['fid'];
        $query = @mysql_query($sql);
        if (@mysql_num_rows($query) == 0) {
          header('location: ?fid_error=' . (int)$_GET['fid']);
        } else {
          $sql = 'UPDATE ' . TABLE_FILES . ' SET file_hits=file_hits+1 WHERE file_id=' . (int)$_GET['fid'];
          @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          ob_clean();
          header('content-type: application/x-download');
          header('cache-control: private');
          header('content-disposition: attachment; filename="' . $row['file_name'] . '"');
          header('content-transfer-encoding: binary');
          readfile($cfg['fileupload_dir'] . '/' . $row['file_prefix'] . '_' . $row['file_name']);
          die;
        }
      } else {
        header('location: ?fid_error=-1');
      }
    }
?>
<div id="div_header">
<div id="div_header_top">
<h1>pToDo - <?php echo HtmlEnt($cfg['site_title'], false); ?></h1>
<form action="?" method="get" id="form_quickjump">
# <input type="text" name="id" id="input_quickjump" accesskey="q" /> <input type="submit" value="<?php echo $lang['go']; ?>" />
</form>
<br style="clear:both" />
</div>
<?php echo (empty($cfg['site_subtitle']) ? '' : HtmlEnt($cfg['site_subtitle'], false) . '<br />'); ?>
</div>
<div id="div_navi" style="clear:both;">
<?php
    if ($_GET['section'] == 'admin') {
      if (UserIsAdmin($_SESSION['ptodo_user_id'])) {
        // Adminlinks auflisten
        $links = array(
          array('navi', $lang['navigation']),
          array('users', $lang['users']),
          array('config', $lang['configs']),
          array('space', $lang['space']),
          array('updatecheck', $lang['updatecheck'])
        );
        $count = count($links);
        for ($i = 0; $i < $count; $i++) {
          $active = ($_GET['sub'] == $links[$i][0] ? ' class="a_navi_active"' : '');
          $top_bottom = ($i > 0 ? ' style="margin-top:5px;"' : '');
          echo '<a href="?section=admin&amp;sub=' . $links[$i][0] . '"' . $active . $top_bottom . '>' . $links[$i][1] . '</a>';
        }
      } else {
        header('location: ?');
      }
    } elseif ($_GET['section'] == 'useradmin') {
      if ($_SESSION['ptodo_user_id'] > -1) {
        // Useradminlinks auflisten
        $links = array(
          array('password', $lang['password']),
          array('email', $lang['email'])
        );
        $count = count($links);
        for ($i = 0; $i < $count; $i++) {
          $active = ($_GET['sub'] == $links[$i][0] ? ' class="a_navi_active"' : '');
          $top_bottom = ($i > 0 ? ' style="margin-top:5px;"' : '');
          echo '<a href="?section=useradmin&amp;sub=' . $links[$i][0] . '"' . $active . $top_bottom . '>' . $links[$i][1] . '</a>';
        }
      } else {
        header('location: ?');
      }
    } elseif ($_GET['section'] == 'help') {
      $count = count($help_data);
      if (!isset($_GET['cid'])) {
        $_GET['cid'] = 0;
      }
      for ($i = 0; $i < $count; $i++) {
        if ($help_data[$i]['admin'] && !UserIsAdmin($_SESSION['ptodo_user_id'])) {
          continue;
        }
        $active = ($_GET['cid'] == $i ? ' class="a_navi_active"' : '');
        $top_bottom = ($i > 0 ? ' style="margin-top:5px;"' : '');
        echo '<a href="?section=help&amp;cid=' . $i . '"' . $active . $top_bottom . '>' . $help_data[$i]['title'] . '</a>';
      }
    } else {
      // Eintrge auflisten
      if (isset($_GET['id']) && empty($_GET['section'])) {
        $sql = 'SELECT navitem_id FROM ' . TABLE_ITEMS . ' WHERE item_id=' . (int)$_GET['id'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $todo_id = (@mysql_num_rows($query) == 0 ? '' : $row['navitem_id']);
      } elseif (isset($_GET['tid'])) {
        $todo_id = (int)$_GET['tid'];
      }
      $sql = 'SELECT navitem_id, navitem_title, navitem_type, navitem_linktarget FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=0 ORDER BY navitem_order';
      $query = @mysql_query($sql);
      $count = @mysql_num_rows($query);
      if ($count == 0) {
        echo $lang['no_item'];
      } else {
        $c = 1;
        if (isset($_GET['id'])) {
          $typeid = $todo_id;
        } else {
          $typeid = -1;
          $types_prefix = array(NAVITEM_GROUP, NAVITEM_LINK, NAVITEM_HTML, NAVITEM_TODO, NAVITEM_FORUM);
          for ($i = 0; $i < count($types_prefix); $i++) {
            $index = GetTypeIdPrefix($types_prefix[$i]) . 'id';
            if (isset($_GET[$index])) {
              $typeid = (int)$_GET[$index];
              break;
            }
          }
        }
        $c = 0;
        while ($row = @mysql_fetch_array($query)) {
          if (!UserAuth($_SESSION['ptodo_user_id'], $row['navitem_id'], AUTH_VIEW)) {
            continue;
          }
          if ($row['navitem_type'] == NAVITEM_GROUP && $typeid != -1) {
             if (isset($_GET['gid'])) {
               $active_group = ($_GET['gid'] == $row['navitem_id']);
             } else {
               $sql_2 = 'SELECT navitem_parentid FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $typeid;
               $query_2 = @mysql_query($sql_2);
               $row_2 = @mysql_fetch_array($query_2);
               $active_group = ($row_2['navitem_parentid'] == $row['navitem_id']);
             }
          } else {
            $active_group = false;
          }
          $top_bottom = ($c > 0 ? ' style="margin-top:5px;"' : '');
          if ($active_group) {
            echo '<div id="div_active_navi"' . $top_bottom . '><b>' . $row['navitem_title'] . ':</b><br />';
            $sql_2 = 'SELECT navitem_id, navitem_title, navitem_type, navitem_linktarget FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . $row['navitem_id'] . ' ORDER BY navitem_order';
            $query_2 = @mysql_query($sql_2);
            $count_2 = @mysql_num_rows($query_2);
            $c_2 = 1;
            while ($row_2 = @mysql_fetch_array($query_2)) {
              if (!UserAuth($_SESSION['ptodo_user_id'], $row_2['navitem_id'], AUTH_VIEW)) {
                continue;
              }
              $active = ($typeid == $row_2['navitem_id'] ? ' class="a_navi_active"' : '');
              $bottom = ($c_2 > 0 ? ' style="margin-top:5px"' : '');
              $type_id = GetTypeIdPrefix($row_2['navitem_type']);
              $target = '';
              if ($row_2['navitem_type'] == NAVITEM_LINK) {
                if ($row_2['navitem_linktarget'] == LINKTARGET_NEW) {
                  $target = ' target="_blank"';
                }
              }
              echo '<a href="?' . $type_id . 'id=' . $row_2['navitem_id'] . '"' . $active . $bottom . $target . '>' . HtmlEnt($row_2['navitem_title']) . '</a>';
              $c_2++;
            }
            echo '</div>';
          } else {
            $active = ($typeid == $row['navitem_id'] ? ' class="a_navi_active"' : '');
            $type_id = GetTypeIdPrefix($row['navitem_type']);
            $target = '';
            if ($row['navitem_type'] == NAVITEM_LINK) {
              if ($row['navitem_linktarget'] == LINKTARGET_NEW) {
                $target = ' target="_blank"';
              }
            }
            echo '<a href="?' . $type_id . 'id=' . $row['navitem_id'] . '"' . $active . $top_bottom . $target . '>' . HtmlEnt($row['navitem_title']) . '</a>';
          }
          $c++;
        }
      }
    }
?>
</div>
<div id="div_headnavi">
<div id="div_headnavi_left">
<?php
    // Links zusammenstellen
    $links = '';
    if (in_array($_GET['section'], array('admin', 'useradmin', 'help'))) {
      $links .= '<a href="?">' . $lang['home'] . '</a>';
      if (!empty($_GET['sub'])) {
        if ($_GET['section'] == 'admin') {
          $links .= ' - <a href="?section=admin">' . $lang['admin_index'] . '</a>';
          if ($_GET['sub'] == 'navi' && !empty($_GET['action'])) {
            $links .= ' - <a href="?section=admin&amp;sub=navi">' . $lang['navigation'] . '</a>';
          } elseif ($_GET['sub'] == 'users' && !empty($_GET['action'])) {
            $links .= ' - <a href="?section=admin&amp;sub=users">' . $lang['users'] . '</a>';
          }
        } elseif ($_GET['section'] == 'useradmin') {
          $links .= ' - <a href="?section=useradmin">' . $lang['useradmin_index'] . '</a>';
          if ($_GET['sub'] == 'password' && !empty($_GET['action'])) {
            $links .= ' - <a href="?section=useradmin&amp;sub=password">' . $lang['password'] . '</a>';
          }
        }
      }
    } elseif (!empty($_GET['bid'])) {
      // Rechte prfen
      if (UserAuth($_SESSION['ptodo_user_id'], $_GET['bid'], AUTH_VIEW)) {
        if (!empty($_GET['pid']) || !empty($_GET['action'])) {
          $links .= '<a href="?bid=' . $_GET['bid'] . (isset($_GET['pid']) && !empty($_GET['action']) ? '&amp;pid=' . $_GET['pid'] : '') . '">' . $lang['back'] . '</a>';
        }
        if (empty($_GET['action']) && $_SESSION['ptodo_user_id'] > -1) {
          // Rechte prfen
          if (UserAuth($_SESSION['ptodo_user_id'], $_GET['bid'], AUTH_ADD)) {
            if (!empty($links)) {
              $links .= ' - ';
            }
            $links .= '<a href="?bid=' . $_GET['bid'] . '&amp;action=add' . (empty($_GET['pid']) ? '' : '&amp;pid=' . $_GET['pid']) . '">' . $lang['add_' . (empty($_GET['pid']) ? 'item' : 'answer')] . '</a>';
          }
          if (!empty($_GET['pid'])) {
            $sql = 'SELECT post_author FROM ' . TABLE_POSTS . ' WHERE post_id=' . $_GET['pid'];
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
            if (($row['post_author'] == $_SESSION['ptodo_user_id'] && UserAuth($_SESSION['ptodo_user_id'], $_GET['bid'], AUTH_EDIT)) || ($row['post_author'] != $_SESSION['ptodo_user_id'] && UserAuth($_SESSION['ptodo_user_id'], $_GET['bid'], AUTH_EDIT_ALL))) {
              $links .= ' - <a href="?bid=' . $_GET['bid'] . '&amp;action=edit&amp;pid=' . $_GET['pid'] . '">' . $lang['edit'] . '</a>';
            }
          }
        }
      }
    } else {
      if (!empty($todo_id)) {
        if (!empty($_GET['tid']) && empty($_GET['action'])) {
          // Rechte prfen
          if (UserAuth($_SESSION['ptodo_user_id'], $_GET['tid'], AUTH_ADD)) {
            $links .= '<a href="?tid=' . $todo_id . '&amp;action=add">' . $lang['add_item'] . '</a>';
          }
        } else {
          $links .= '<a href="?tid=' . $todo_id . '">' . $lang['overview'] . '</a>';
        }
      }
      if (!empty($_GET['id'])) {
        // Id des Authors auslesen
        $sql = 'SELECT item_author FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
        $query = @mysql_query($sql);
        if (@mysql_num_rows($query) > 0) {
          $row = @mysql_fetch_array($query);
          $item_author = $row['item_author'];
        } else {
          $item_author = 0;
        }
        if (!empty($_GET['action'])) {
            $links .= ' - <a href="?id=' . $_GET['id'] . '">' . $lang['back'] . '</a>';
        } elseif ($_SESSION['ptodo_user_id'] > -1) {
          // Rechte prfen
          if ($item_author > 0) {
            if (($item_author == $_SESSION['ptodo_user_id'] && UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_EDIT)) || ($item_author != $_SESSION['ptodo_user_id'] && UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_EDIT_ALL))) {
              $links .= ' - <a href="?id=' . $_GET['id'] . '&amp;action=edit">' . $lang['edit'] . '</a>';
            }
            if (($item_author == $_SESSION['ptodo_user_id'] && UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_DELETE)) || ($item_author != $_SESSION['ptodo_user_id'] && UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_DELETE_ALL))) {
              $links .= ' - <a href="?id=' . $_GET['id'] . '&amp;action=delete">' . $lang['delete'] . '</a>';
            }
          }
        }
      }
      if (!empty($_GET['id']) || !empty($todo_id)) {
        if (!empty($links)) {
          $links .= ' - ';
        }
        $links .= '<a href="?tid=' . $todo_id . '&amp;action=list&amp;type=' . STATUS_OPEN . '">' . $lang['open'] . '</a> - <a href="?tid=' . $todo_id . '&amp;action=list&amp;type=' . STATUS_CLOSE . '">' . $lang['close'] . '</a> - <a href="?tid=' . $todo_id . '&amp;action=list&amp;type=' . STATUS_DONE . '">' . $lang['done'] . '</a> - <a href="?tid=' . $todo_id . '&amp;action=list&amp;type=' . STATUS_NODEV . '">' . $lang['nodev'] . '</a> - <a href="?tid=' . $todo_id . '&amp;action=search">' . $lang['search'] . '</a>';
        if ($_GET['action'] == 'view' && !empty($_GET['search']) && !empty($_GET['place'])) {
          $links .= ' - <a href="?tid=' . $todo_id . '&amp;action=search&amp;search=' . $_GET['search'] . '&amp;place=' . $_GET['place'] . '">' . $lang['back'] . '</a>';
        }
      }
    }
    echo $links;
?>
</div>
<div id="div_headnavi_right">
<?php
    // Links zusammenstellen
    echo (UserIsAdmin($_SESSION['ptodo_user_id']) ? '<a href="?section=admin">' . $lang['admin'] . '</a> - ' : '') . ($_SESSION['ptodo_user_id'] > -1 ? '<a href="?section=useradmin">' . $lang['useradmin'] . '</a> - ' : '') . '<a href="?section=help">' . $lang['help'] . '</a> - ' . ($_SESSION['ptodo_user_id'] > -1 ? '<a href="?logout=1">' . $lang['logout'] . '</a>' : '<a href="?login=1&amp;' . str_replace(array('logout=1', '&'), array('', '&amp;'), $_SERVER['QUERY_STRING']) . '">' . $lang['login'] . '</a>');
?>
</div>
</div>
<div id="div_content">
<?php
    if (isset($_GET['fid_error'])) { // Fehler mit Dateiid
      if ($_GET['fid_error'] == -1) {
        ShowError($lang['auth_download_error']);
      } else {
        ShowError(str_replace('%s', (int)$_GET['fid_error'], $lang['file_error']));
      }
    } else if (isset($_GET['lid'])) { // Link weiterleiten
      $sql = 'SELECT navitem_html, navitem_linktarget FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['lid'] . ' AND navitem_type=' . NAVITEM_LINK;
      $query = @mysql_query($sql);
      if (@mysql_num_rows($query) == 0) {
        ShowError(str_replace('%s', $_GET['lid'], $lang['link_error']));
      } else {
        // Rechte prfen
        if (UserAuth($_SESSION['ptodo_user_id'], $_GET['lid'], AUTH_VIEW)) {
          $row = @mysql_fetch_array($query);
          if ($row['navitem_linktarget'] == LINKTARGET_FRAME) {
            echo nl2br(file_get_contents($row['navitem_html']));
          } else {
            header('location: ' . $row['navitem_html']);
          }
        } else {
          ShowError($lang['auth_link_error']);
        }
      }
    } elseif (isset($_GET['hid'])) { // HTML Seite anzeigen
      $sql = 'SELECT navitem_html FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['hid'] . ' AND navitem_type=' . NAVITEM_HTML;
      $query = @mysql_query($sql);
      if (@mysql_num_rows($query) == 0) {
        ShowError(str_replace('%s', $_GET['hid'], $lang['html_error']));
      } else {
        // Rechte prfen
        if (UserAuth($_SESSION['ptodo_user_id'], $_GET['hid'], AUTH_VIEW)) {
          $row = @mysql_fetch_array($query);
          echo $row['navitem_html'];
        } else {
          ShowError($lang['auth_html_error']);
        }
      }
    } elseif (isset($_GET['gid'])) { // Gruppe anzeigen
      $sql = 'SELECT COUNT(navitem_id) AS NavitemCount FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['gid'] . ' AND navitem_type=' . NAVITEM_GROUP;
      $query = @mysql_query($sql);
      $row = @mysql_fetch_array($query);
      if ($row['NavitemCount'] == 0) {
        ShowError(str_replace('%s', $_GET['gid'], $lang['group_error']));
      } else {
        // Rechte prfen
        if (UserAuth($_SESSION['ptodo_user_id'], $_GET['gid'], AUTH_VIEW)) {
          echo $lang['select_subitem'];
        } else {
          ShowError($lang['auth_group_error']);
        }
      }
    } elseif (isset($_GET['bid'])) { // Forum anzeigen
      require('modules/forum.php');
    } elseif (isset($_GET['tid'])) { // ToDo-Liste anzeigen
      require('modules/todo.php');
    } elseif (isset($_GET['id']) && empty($_GET['section'])) { // Eintrge anzeigen
      require('modules/items.php');
    } elseif ($_GET['section'] == 'admin') { // Admin anzeigen
      require('modules/admin.php');
    } elseif ($_GET['section'] == 'useradmin') { // Useradmin anzeigen
      require('modules/useradmin.php');
    } elseif ($_GET['section'] == 'help') { // Hilfe anzeigen
      if ($_GET['cid'] < 0 || $_GET['cid'] > count($help_data) - 1) {
        ShowError(str_replace('%s', $_GET['cid'], $lang['help_error']));
      } else {
        echo $help_data[$_GET['cid']]['text'];
      }
    } else {
      // Username auslesen
      echo str_replace('%s', GetUserName($_SESSION['ptodo_user_id']), $lang['index_welcome']) . '<br /><br />';
      echo $lang['index_text'];
    }
?>
</div>
<br style="clear:left" />
<?php
  } else {
    require('modules/login.php');
  }
  /////////////////////////////////////////////////////////////////////////
  //                                                                     //
  //  Der Copyrighthinweis muss in unvernderter Form erhalten bleiben,  //
  //  sonst ist die Nutzung dieses Scriptes untersagt!                   //
  //                                                               Pr0g  //
  /////////////////////////////////////////////////////////////////////////
?>
<div id="div_copyright">
[<?php echo (isset($_SESSION['ptodo_user_id']) ? ($_SESSION['ptodo_user_id'] > -1 ? str_replace('%s', GetUserName($_SESSION['ptodo_user_id']), $lang['logged_in']) . ' | ' : '') : '') . 'v' . $version; ?> | copyright &copy; 2005 - 2006 <a href="http://pr0g.net" target="_blank">pr0g.net</a>]
</div>
</body>
</html>
<?php
  // Puffer nun ausgeben
  ob_end_flush();
?>