<?php
  // Konfiguration einbinden
  require('config.php');
  
  // Datenbankverbindung herstellen
  $connect = @mysql_connect($dbHost, $dbUser, $dbPass) or die('Konnte keine Verbindung zum Datenbankserver aufbauen!');
  $selectDB = @mysql_select_db($dbName, $connect) or die('Konnte die Datenbank <b>' . $dbName . '</b> nicht auswhlen!');
  unset($dbHost, $dbUser, $dbPass);

  // Konstanten einbinden
  require('modules/constants.php');

  // Neue Version
  $version = '2.1.6';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>pToDo v<?php echo $version; ?> Installation</title>
<link rel="stylesheet" type="text/css" href="screen.css" />
<style type="text/css">
.span_g, .span_r {
  font-weight: bold;
}

.span_g {
  color: green;
}

.span_r {
  color: red;
}
</style>
</head>
<body>
<div id="div_login" style="width:400px">
<b style="text-decoration:underline">pToDo v<?php echo $version; ?> Installation:</b><br />
<br />
<?php
  if (!empty($_POST['username']) && !empty($_POST['password'])) {
    $error = false;

    // SQL Anweisungen
    $sql = array();
    $sql[] = array('Abh&auml;ngigkeiten-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_ITEMLINK . ' (item_id  INT( 10 ) UNSIGNED NOT NULL, linkitem_id INT( 10 ) UNSIGNED NOT NULL) TYPE=MyISAM;');
    $sql[] = array('Foren-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_POSTS . ' (post_id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT, navitem_id MEDIUMINT(8) UNSIGNED NOT NULL, post_parent INT(10) UNSIGNED NOT NULL, post_child INT(10) UNSIGNED NOT NULL, post_time INT(11) UNSIGNED NOT NULL, post_author MEDIUMINT(8) UNSIGNED NOT NULL, post_title VARCHAR(255) NOT NULL, post_text TEXT NOT NULL, PRIMARY KEY (post_id)) TYPE=MyISAM;');
    $sql[] = array('Abonnements-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_ITEMWATCH . ' (user_id MEDIUMINT(8) UNSIGNED NOT NULL, item_id INT(10) UNSIGNED NOT NULL) TYPE=MyISAM;');
    $sql[] = array('Dateien-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_FILES . ' (file_id int(10) unsigned NOT NULL auto_increment, item_id int(10) unsigned NOT NULL default \'0\', file_name varchar(255) NOT NULL default \'\', file_prefix mediumint(8) unsigned NOT NULL default \'0\', developer_id mediumint(8) unsigned NOT NULL default \'0\', file_hits INT( 10 ) NOT NULL, PRIMARY KEY  (file_id)) TYPE=MyISAM;');
    $sql[] = array('History-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_HISTORY . ' (item_id int(10) unsigned NOT NULL default \'0\', developer_id mediumint(8) unsigned NOT NULL default \'0\', history_action tinyint(2) unsigned NOT NULL default \'0\', history_time int(11) unsigned NOT NULL default \'0\', history_text text NOT NULL) TYPE=MyISAM;');
    $sql[] = array('Eintr&auml;ge-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_ITEMS . ' (item_id int(10) unsigned NOT NULL auto_increment, navitem_id mediumint(8) unsigned NOT NULL default \'0\', item_author mediumint(8) unsigned NOT NULL default \'0\', item_title varchar(255) NOT NULL default \'\', item_text text NOT NULL, item_priority tinyint(1) unsigned NOT NULL default \'0\', item_type TINYINT(1) unsigned NOT NULL, item_starttime int(11) unsigned NOT NULL default \'0\', item_endtime int(11) unsigned NOT NULL default \'0\', item_done tinyint(1) unsigned NOT NULL default \'0\', developer_id mediumint(8) unsigned NOT NULL default \'0\', PRIMARY KEY  (item_id)) TYPE=MyISAM;');
    $sql[] = array('Navigations-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_NAVITEMS . ' (navitem_id mediumint(8) unsigned NOT NULL auto_increment, navitem_parentid mediumint(8) unsigned NOT NULL default \'0\', navitem_type tinyint(1) unsigned NOT NULL default \'0\', navitem_title varchar(255) NOT NULL default \'\', navitem_order mediumint(8) unsigned NOT NULL default \'0\', navitem_html text NOT NULL, navitem_linktarget TINYINT(1) unsigned NOT NULL, PRIMARY KEY  (navitem_id)) TYPE=MyISAM;');
    $sql[] = array('Benutzer-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_USERS . ' (user_id mediumint(8) unsigned NOT NULL auto_increment, group_id MEDIUMINT(8) UNSIGNED NOT NULL, user_name varchar(255) NOT NULL default \'\', user_password varchar(32) NOT NULL default \'\', user_email varchar(255) NOT NULL default \'\', user_isadmin tinyint(1) unsigned NOT NULL default \'0\', user_loginkey varchar(13) NOT NULL default \'\', user_deleted tinyint(1) unsigned NOT NULL default \'0\', PRIMARY KEY  (user_id)) TYPE=MyISAM;');
    $sql[] = array('Adminaccount wird angelegt', 'INSERT INTO ' . TABLE_USERS . ' (user_name, group_id, user_password, user_isadmin) VALUES (\'' . $_POST['username'] . '\', 1, \'' . md5($_POST['password']) . '\', 1);');
    $sql[] = array('Gruppen-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_GROUPS . ' (group_id MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT, group_name VARCHAR(255) NOT NULL, PRIMARY KEY (group_id)) TYPE=MyISAM;');
    $sql[] = array('Standardgruppe wird eingetragen', 'INSERT INTO ' . TABLE_GROUPS . ' VALUES (\'\', \'Default\');');
    $sql[] = array('G&auml;stegruppe wird eingetragen', 'INSERT INTO ' . TABLE_GROUPS . ' VALUES (\'\', \'Guests\');');
    $sql[] = array('Rechte-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_RIGHTS . ' (group_id MEDIUMINT(8) UNSIGNED NOT NULL, navitem_id INT(10) UNSIGNED NOT NULL, rights_auth INT(10) UNSIGNED NOT NULL) TYPE=MyISAM;');
    $sql[] = array('Versionen-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_VERSIONS . ' (version_id int(10) unsigned NOT NULL auto_increment, version_time int(11) unsigned NOT NULL default \'0\', navitem_id mediumint(8) unsigned NOT NULL default \'0\', version_text varchar(255) NOT NULL default \'\', PRIMARY KEY (version_id)) TYPE=MyISAM;');
    $sql[] = array('Konfig-Tabelle wird angelegt', 'CREATE TABLE ' . TABLE_CONFIG . ' (config_name varchar(255) NOT NULL default \'\', config_value varchar(255) NOT NULL default \'\') TYPE=MyISAM;');
    $sql[] = array('Einstellung #1 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'admin_email\', \'\');');
    $sql[] = array('Einstellung #2 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'site_title\', \'Projektaufgaben sinnvoll im Team planen\');');
    $sql[] = array('Einstellung #3 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'site_subtitle\', \'\');');
    $sql[] = array('Einstellung #4 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'setdone_bydev\', \'0\');');
    $sql[] = array('Einstellung #5 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'adddependence_byauthor\', \'0\');');
    $sql[] = array('Einstellung #6 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'force_comments\', \'15\');');
    $sql[] = array('Einstellung #7 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'navibox_width\', \'100\');');
    $sql[] = array('Einstellung #8 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'lastitems_count\', \'10\');');
    $sql[] = array('Einstellung #9 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'items_per_page\', \'25\');');
    $sql[] = array('Einstellung #10 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'fileupload_dir\', \'file_upload\');');
    $sql[] = array('Einstellung #11 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'fileupload_exts\', \'txt,jpg,png,zip\');');
    $sql[] = array('Einstellung #12 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'fileupload_maxsize\', \'102400\');');
    $sql[] = array('Einstellung #13 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'guest_mode\', \'0\');');
    $sql[] = array('Einstellung #14 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'type_prefix_other\', \'[ * ]\');');
    $sql[] = array('Einstellung #15 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'type_prefix_feature\', \'[ADD]\');');
    $sql[] = array('Einstellung #16 wird eingetragen', 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'type_prefix_bugfix\', \'[FIX]\');');

    // Installation durchfhren
    foreach ($sql as $sql_query) {
      echo $sql_query[0] . ': ';
      if (@mysql_query($sql_query[1])) {
        echo '<span class="span_g">Abgeschlossen!</span><br />';
      } else {
        $error = true;
        echo '<span class="span_r">Fehler!</span><br />';
      }
    }

    echo '<br /><br />';
    if ($error) {
      echo 'Ein Fehler ist aufgetreten: ' . mysql_error();
    } else {
      echo 'Installation abgeschlossen. L&ouml;schen Sie diese Datei nun von Ihrem Server!';
    }
  } else {
?>
Diese Installation wird alle n&ouml;tigen Tabellen in Ihrer Datenbank anlegen.<br />
<br />
Bitte geben Sie einen Benuternamen, sowie ein Passwort f&uuml;r den Adminaccount an:<br />
<br />
<form action="?" method="post">
<table cellpadding="2" cellspacing="0" style="margin:0 auto">
<tr><td>Name:</td><td><input type="text" name="username" /></td></tr>
<tr><td>Passwort:</td><td><input type="password" name="password" /></td></tr>
<tr><td style="text-align:center" colspan="2"><br /><input type="submit" name="send" value="Installieren" /></td></tr>
</table>
</form>
<?php
  }
?>
</div>
<div id="div_copyright">
copyright &copy; 2005 - 2006 <a href="http://pr0g.net" target="_blank">pr0g.net</a>
</div>
</body>
</html>