<?php
/*-----------------------------------------------------------------------------
  pToDo - Sprachdatei [Deutsch]
  -----------------------------
  Deutsche Sprachdatei fr pToDo
  ------------------------------
  Lizenz:

    Copyright (C) 2005 - 2006 Andreas "Pr0g" Droesch

    pToDo ist Freeware und darf ausdrcklich weitergegeben werden, sofern
    dies kostenlos und in unvernderter Form des Scripts geschieht.

    Der Autor haftet nicht fr Schden, die durch die Nutzung dieses Scripts
    entstanden sind!
  -----------------------------------------------------------------------------
  Author:

    Andreas "Pr0g" Droesch
    http://pr0g.net,
    webmaster@pr0g.net
    All Rights reserved.

  Version:

    siehe index.php
-----------------------------------------------------------------------------*/

  // Strings zur Nutzung im Script
  $lang = array(
    // Formatangaben
    'time_format' => 'd.m.Y, H:i \U\h\r', // bspw. "01.01.2006, 01:15 Uhr"
    'date_format' => 'd.m.Y', // bspw. "01.01.2006"
    'date_select' => '%day . %month . %year', // %day, %month, %year = Auswahllisten fr ein Datum
    
    // Allgemeines
    'yes'       => 'Ja',
    'no'        => 'Nein',
    'up'        => 'Hoch',
    'down'      => 'Runter',
    'back'      => 'Zur&uuml;ck',
    'go'        => 'Go',
    'comment'   => 'Kommentar',
    'message'   => 'Nachricht',
    'send'      => 'Senden',
    'error'     => 'Fehler',
    'developer' => 'Entwickler',
    'users'     => 'Benutzer',
    'password'  => 'Passwort',
    'overview'  => '&Uuml;bersicht',
    'items'     => 'Eintr&auml;ge',
    'entire'    => 'Gesamt',
    'unlimited' => 'unbegrenzt',
    'guest'     => 'Gast',
    'email'     => 'E-Mail',
    'no_email'  => 'Sie haben noch keine E-Mailadresse in der Useradmin angegeben!',
    'logged_in' => 'Eingeloggt als %s', // %s = Benutzername
    'go'        => 'Go',
    'name'      => 'Name',
    'type'      => 'Typ',
    'value'     => 'Wert',
    'tables'    => 'Tabellen',
    'options'   => 'Optionen',
    'output'    => 'Ausgabe',
    'text'      => 'Text',
    'html'      => 'HTML',
    'code'      => 'Code',
    'hits'      => 'Hits',

    // Navigationslinks
    'home'      => 'Home',
    'search'    => 'Suchen',
    'help'      => 'Hilfe',
    'admin'     => 'Admin',
    'useradmin' => 'Useradmin',
    'logout'    => 'Ausloggen',

    // Index
    'index_welcome' => 'Willkommen <b>%s</b>,', // %s = Benutzername
    'index_text'    => 'bitte w&auml;hlen Sie einen Eintrag aus der linken Navigation.',

    // Listen
    'page'        => 'Seite',
    'sort'        => 'Sortierung',
    'author'      => 'Autor',
    'id'          => 'Id',
    'title'       => 'Titel',
    'date'        => 'Datum',
    'enddate'     => 'Abschlussdatum',
    'description' => 'Beschreibung',
    
    // Prioritten
    'priority' => 'Priorit&auml;t',
    'veryhigh' => 'sehr hoch',
    'high'     => 'hoch',
    'normal'   => 'normal',
    'low'      => 'niedrig',
    'verylow'  => 'sehr niedrig',
    
    // Typen
    'other'          => 'Sonstiges',
    'feature'        => 'Feature',
    'featurerequest' => 'Featurerequest',
    'bugreport'      => 'Bugreport',
    'bugfix'         => 'Bugfix',
    'other_short'    => 'S',
    'feature_short'  => 'F',
    'bug_short'      => 'B',
    
    // Meldungen
    'no_item'          => 'Kein Eintrag vorhanden!',
    'no_items'         => 'Keine Eintr&auml;ge vorhanden!',
    'select_subitem'   => 'Bitte w&auml;hlen Sie einen Untereintrag aus der linken Navigation.',
    'delete_item_info' => 'Sind Sie sicher, dass der Eintrag #%s und die dazugeh&ouml;rigen Historyeintr&auml;ge gel&ouml;scht werden sollen? Diese Aktion kann nicht r&uuml;ckg&auml;ngig gemacht werden!', // %s = Id
    'edit_reason'      => 'Grund der &Auml;nderung',
    'not_closed'       => 'Noch nicht abgeschlossen!',
    'no_developer'     => 'Kein Entwickler zugeteilt!',
    'invalid_id'       => 'Ung&uuml;ltige Id!',
    'invalid_date'     => 'Ung&uuml;ltiges Datum!',
    'empty_title'      => 'Sie m&uuml;ssen einen Titel angeben!',
    'empty_desc'       => 'Sie m&uuml;ssen eine Beschreibung angeben!',

    // Aktionen
    'add'          => 'Eintragen',
    'sadd'         => 'eintragen',
    'move'         => 'Verschieben',
    'edit'         => 'Bearbeiten',
    'delete'       => 'L&ouml;schen',
    'delete_small' => 'l&ouml;schen',
    'add_item'     => 'Eintrag hinzuf&uuml;gen',
    'add_answer'   => 'Antwort hinzuf&uuml;gen',
    'self_set'     => 'Diesen Eintrag sich selber zuordnen?',
    'set_add'      => 'Zuweisung beim Erstellen!',
    'add_new_item' => 'Einen neuen Eintrag in die Liste einf&uuml;gen',
    'delete_item'  => 'Eintrag l&ouml;schen',
    'edit_item'    => 'Eintrag bearbeiten',
    'item_close'   => 'abschlie&szlig;en',
    'item_open'    => '&ouml;ffnen',
    'item_done'    => 'abnehmen',
    'remove'       => 'austragen',
    'add_comment'  => 'Kommentar schreiben',
    'add_upload'   => 'Nach dem Eintragen noch eine Datei anh&auml;ngen?',
    'subscribed'   => 'Abonniert',
    'subscribe'    => 'abonnieren',
    'no_subscribe' => 'nicht mehr abonnieren',
    'show_title'   => 'Titel anzeigen',
    'preview'      => 'Vorschau',
    'notice'       => 'Hinweis',

    // Statuskennungen
    'open'           => 'Offene',
    'close'          => 'Geschlossene',
    'done'           => 'Abgenommene',
    'nodev'          => 'Unzugeordnete',
    'item_added'     => 'Eingetragen',
    'item_completed' => 'Abgeschlossen',
    
    // Navigationstypen
    'group'     => 'Gruppe',
    'weblink'   => 'Weblink',
    'html_site' => 'HTML Seite',
    'todo_list' => 'ToDo-Liste',
    'forum'     => 'Forum',
    
    // Kommentare
    'comment_optional' => 'Dieser Kommentar ist optional!',
    'comment_force'    => 'Dieser Kommentar muss angegeben werden!',
    
    // Fehlermeldungen
    'db_connection_error'     => 'Konnte keine Verbindung zum Datenbankserver aufbauen!',
    'db_database_error'       => 'Konnte die Datenbank <b>%s</b> nicht ausw&auml;hlen!', // %s = Datenbankname
    'file_error'              => 'Eine Datei mit der angegebenen Id "%s" existiert nicht!', // %s = Id
    'link_error'              => 'Ein Link mit der angegebenen Id "%s" existiert nicht!', // %s = Id
    'html_error'              => 'Eine HTML Seite mit der angegebenen Id "%s" existiert nicht!', // %s = Id
    'group_error'             => 'Eine Gruppe mit der angegebenen Id "%s" existiert nicht!', // %s = Id
    'todo_error'              => 'Eine ToDo-Liste mit der angegebenen Id "%s" existiert nicht!', // %s = Id
    'item_error'              => 'Ein ToDo-Listen Eintrag mit der angegebenen Id "%s" existiert nicht!', // %s = Id
    'linkitem_error'          => 'Der ToDo-Listen Eintrag mit der angegebenen Id "%s" wurde schon als Abh&auml;ngigkeit eingetragen!', // %s = Id
    'item_selfdepend_error'   => 'Ein Eintrag kann nicht von sich selbst abh&auml;ngig sein!',
    'close_error'             => 'Sie k&ouml;nnen den Eintrag mit der Id "%s" nicht abschlie&szlig;en!', // %s = Id
    'help_error'              => 'Ein Hilfeeintrag mit der Id "%s" existiert nicht!', // %s = Id
    'forum_error'             => 'Ein Forum mit der angegebenen Id "%s" existiert nicht!', // %s = Id
    'post_error'              => 'Ein Foreneintrag mit der angegebenen Id "%s" existiert in diesem Forum nicht!', // %s = Id
    'auth_download_error'     => 'Sie haben keine Berechtigung diese Datei herunterzuladen!',
    'auth_link_error'         => 'Sie haben keine Berechtigung diesen Link zu &ouml;ffnen!',
    'auth_html_error'         => 'Sie haben keine Berechtigung diese HTML Seite zu &ouml;ffnen!',
    'auth_group_error'        => 'Sie haben keine Berechtigung diese Gruppe anzuzeigen!',
    'auth_forum_error'        => 'Sie haben keine Berechtigung dieses Forum anzuzeigen!',
    'auth_forum_add_error'    => 'Sie haben keine Berechtigung einen Beitrag in dieses Forum zu erstellen!',
    'auth_forum_edit_error'   => 'Sie haben keine Berechtigung diesen Beitrag zu bearbeiten!',
    'auth_todo_error'         => 'Sie haben keine Berechtigung diese ToDo-Liste anzusehen!',
    'auth_todo_add_error'     => 'Sie haben keine Berechtigung einen Eintrag in dieser ToDo-Liste zu erstellen!',
    'auth_item_error'         => 'Sie haben keine Berechtigung diesen Eintrag anzusehen!',
    'auth_item_sub_error'     => 'Sie haben keine Berechtigung diesen Eintrag zu abonnieren!',
    'auth_item_dev_error'     => 'Sie haben keine Berechtigung als Entwickler f&uuml;r diesen Eintrag t&auml;tig zu sein!',
    'auth_item_com_error'     => 'Sie haben keine Berechtigung einen Kommentar zu diesem Eintrag zu schreiben!',
    'auth_item_del_error'     => 'Sie haben keine Berechtigung diesen Eintrag zu l&ouml;schen!',
    'auth_item_edit_error'    => 'Sie haben keine Berechtigung diesen Eintrag zu bearbeiten!',
    'auth_download_error'     => 'Sie haben keine Berechtigung eine Datei auf den Server zu laden!',
    'auth_download_del_error' => 'Sie haben keine Berechtigung diese Datei zu l&ouml;schen!',
    'version_select_error'    => 'Sie m&uuml;ssen eine g&uuml;ltige Start- und Endversion ausw&auml;hlen!',
    'version_sort_error'      => 'Die Startversion darf nicht gr&ouml;&szlig;er als die Endversion sein!',

    // Projektstatus
    'status_no_items' => 'Projektstatus: keine Eintr&auml;ge vorhanden',
    'status'          => 'Projektstatus',
    'status_open'     => 'Offen',
    'status_close'    => 'Geschlossen',
    'status_done'     => 'Abgenommen',
    'status_complete' => 'fertiggestellt',

    // Die letzten Eintrge
    'last_open'  => 'offenen',
    'last_close' => 'geschlossenen',
    'last_done'  => 'abgenommenen',
    'last_items' => 'Die letzten %s', // %s = Eintragsanzahl
    'show_all'   => 'Alle %s Eintr&auml;ge anzeigen...', // %s = Eintragsanzahl

    // Forum
    'complete_thread' => 'Kompletter Thread',
    'add_thread'      => 'Einen neuen Thread einf&uuml;gen',
    'add_post'        => 'Einen Antwortpost einf&uuml;gen',
    'edit_post'       => 'Post bearbeiten',

    // Suche
    'search_result' => 'Suchergebnis',
    'search_word'   => 'Suchbegriff',
    'search_place'  => 'Suchort',
    'search_info'   => 'Ein Sternchen (*) im Suchbegriff kann als Platzhalter f&uuml;r eine beliebige Anzahl an Zeichen eingesetzt werden.',
    'sort_desc'     => 'Absteigend',
    'sort_asc'      => 'Aufsteigend',

    // Dateioperationen
    'download'            => 'Download',
    'file'                => 'Datei',
    'files'               => 'Dateien',
    'file_types'          => 'Erlaubte Dateitypen',
    'file_size'           => 'Maximale Dateigr&ouml;&szlig;e',
    'file_type_get_error' => 'Der Dateityp konnte nicht ermittelt werden!',
    'file_type_error'     => 'Der Dateityp "*.%s" ist nicht zugelassen!', // %s = Dateierweiterung
    'file_size_error'     => 'Es sind nur Dateien mit einer maximalen Gr&ouml;&szlig;e von %s zugelassen!', // %s = Dateigre
    'file_move_error'     => 'Das Script hat keine Berechtigung die Datei auf dem Server zu speichern!',
    'upload_file'         => 'Datei hochladen',
    'upload'              => 'Hochladen',
    'delete_file'         => 'Datei l&ouml;schen',
    'delete_file_info'    => 'Sind Sie sicher, dass die Datei "%s" gel&ouml;scht werden sollen? Diese Aktion kann nicht r&uuml;ckg&auml;ngig gemacht werden!', // %s = Dateiname

    // Abhngigkeiten
    'dependences'     => 'Abh&auml;ngig von',
    'dependence_add'  => 'Abh&auml;ngigkeit eintragen',
    'dependences_reg' => 'Eingetragen in',

    // Changelog
    'version'          => 'Version',
    'project_version'  => 'Projektversion',
    'this_version'     => 'Aktuelle Version',
    'new_version'      => 'Neue Version',
    'no_version'       => 'Nicht gesetzt!',
    'version_set'      => 'Neue Version setzen',
    'changelog'        => 'Changelog',
    'changelog_gen'    => 'Changelog generieren',
    'version_date'     => 'Versionsdatum',
    'version_id'       => 'Versionsnummer',
    'version_overview' => 'Versions&uuml;bersicht',
    'set_last_version' => 'Versionsdatum der Vorversion setzen',
    'versions_exists'  => 'Versionen vorhanden',
    'version_edit'     => 'Version bearbeiten',
    'version_items'    => 'Abgenommene Eintr&auml;ge dieser Version',
    'from_to'          => 'Von %start bis %end', // %start = Versionsauswahl, %end = Versionsauswahl
    'show_code'        => 'Code anzeigen',
    'item_prefix'      => 'Eintragsprefixe',
    'show_prefix'      => 'Prefixe anzeigen',
    'show_versiondate' => 'Versionsdatum anzeigen',
    'open_date_info'   => 'Hinweis: Wird das Datum nicht gesetzt (--.--.----), so gilt die Version als noch nicht ver&ouml;ffentlicht. Das Datum ist also noch offen.',
    'sort_output'      => 'Titel alphabetisch sortieren',
    
    // History
    'history'                       => 'History',
    'no_history'                    => 'Keine History vorhanden!',
    'history_edit'                  => 'Bearbeitet von %s', // %s = Entwicklername
    'history_close'                 => 'Geschlossen von %s', // %s = Entwicklername
    'history_open'                  => 'Ge&ouml;ffnet von %s', // %s = Entwicklername
    'history_done'                  => 'Abgenommen von %s', // %s = Entwicklername
    'history_setdev'                => '%s hat sich eingetragen', // %s = Entwicklername
    'history_unsetdev'              => '%s hat sich ausgetragen', // %s = Entwicklername
    'history_comment'               => 'Kommentar von %s', // %s = Entwicklername
    'history_fileadd'               => '%s hat eine Datei angehangen', // %s = Entwicklername
    'history_filedelete'            => '%s hat eine Datei entfernt', // %s = Entwicklername
    'history_fileadd_text'          => 'Datei "%s" angehangen', // %s = Dateiname
    'history_filedelete_text'       => 'Datei "%s" entfernt', // %s = Dateiname
    'history_dependenceadd'         => '%s hat eine Id eingetragen', // %s = Entwicklername
    'history_dependencedelete'      => '%s hat eine Id ausgetragen', // %s = Entwicklername
    'history_dependenceadd_text'    => 'Eintrag #%s als Abhngigkeit eingetragen', // %s = Id | Umlaute belassen!
    'history_dependencedelete_text' => 'Eintrag #%s als Abhngigkeit ausgetragen', // %s = Id | Umlaute belassen!
    
    // Login
    'login'       => 'Login',
    'login_info'  => 'Bitte geben Sie ihren Benutzernamen und Passwort ein',
    'login_auto'  => 'Autologin',
    'login_guest' => 'G&auml;stelogin',
    'login_error' => 'Benutzername oder Password ung&uuml;ltig!',
    
    // BBCodes
    'bbcode_0' => 'Fett: [b]...[/b]',
    'bbcode_1' => 'Unterstrichen: [u]...[/u]',
    'bbcode_2' => 'Kursiv: [i]...[/i]',
    'bbcode_3' => 'Code: [code]...[/code]',
    'bbcode_4' => 'Link: [url]...[/url], [url=...]...[/url]',
    'bbcode_5' => 'Email: [email]...[/email]',
    
    // Admin
    'administration'  => 'Administration',
    'admin_index'     => 'Adminindex',
    'useradmin_index' => 'Useradminindex',
    'updatecheck'     => 'Updatecheck',
    'admin_text'      => 'Bitte w&auml;hlen Sie einen Administrationspunkt aus der linken Auflistung.',

    // Admin - Navigation
    'navigation'           => 'Navigation',
    'navi_add'             => 'Neuen Eintrag hinzuf&uuml;gen',
    'navi_add_sub'         => 'Neuen Untereintrag hinzuf&uuml;gen',
    'navi_move'            => 'Eintrag verschieben',
    'navi_type'            => 'Eintragstyp',
    'navi_title'           => 'Eintragstitel',
    'group_root'           => 'Hauptknoten (Root)',
    'html_code'            => 'HTML Code',
    'select_group'         => 'In welche Gruppe soll der Eintrag verschoben werden?',
    'navi_delete_todoinfo' => 'mit allen dazugeh&ouml;rigen Listeineintr&auml;gen und Logs',
    'navi_delete_todomove' => 'Die Gruppe enth&auml;lt noch Untereintr&auml;ge. W&auml;hlen Sie eine andere Gruppe aus, in welche die Eintr&auml;ge vor dem L&ouml;schen der Gruppe verschoben werden sollen',
    'navi_delete_info'     => 'Sind Sie sicher, dass der Eintrag "%s" %s2gel&ouml;scht werden soll? Diese Aktion kann nicht mehr r&uuml;ckg&auml;ngig gemacht werden!', // %s = Eintragstitel, %s2 = $lang['navi_todo_info']
    'navi_item_error'      => 'Ein Navigationseintrag mit der angegebenen Id "%s" existiert nicht!', // %s = Id
    'navi_linktarget'      => 'Linkziel',
    'navi_targetself'      => 'Dieses Browserfenster',
    'navi_targetframe'     => 'Inhaltsbereich von pToDo',
    'navi_targetnew'       => 'Neues Browserfenster',

    // Admin - Benutzer
    'user_add_new'        => 'Neuen Benutzer hinzuf&uuml;gen',
    'user_add'            => 'Benutzer eintragen',
    'user_edit'           => 'Benutzer bearbeiten',
    'user_delete'         => 'Benutzer l&ouml;schen',
    'user_password_error' => 'Das wiederholte Passwort stimmt nicht mit dem ersten &uuml;berein, bitte geben Sie das Passwort erneut ein.',
    'user_name_error'     => 'Ein Benutzer mit diesem Namen existiert bereits. Bitte w&auml;hlen Sie einen anderen Namen.',
    'user_admin_error'    => 'Sie k&ouml;nnen Ihren eigenen Adminstatus nicht ver&auml;ndern!',
    'user_account_error'  => 'Sie k&ouml;nnen Ihren eigenen Account nicht l&ouml;schen!',
    'user_id_error'       => 'Ein Benutzer mit der angegebenen Id "%s" existiert nicht!', // %s = Id
    'user_name'           => 'Benutzername',
    'password_repeat'     => 'Password wiederholen',
    'admin_status'        => 'Adminrechte',
    'user_admin_status'   => 'Admin',
    'password_info'       => 'Feld leer lassen, wenn das Passwort nicht ge&auml;ndert werden soll!',
    'user_delete_text'    => 'Sind Sie sicher, dass der Benutzer "%s" gel&ouml;scht werden soll?', // %s = Benutzername
    'users_exists'        => 'Vorhandene Benutzer',
    'users_delete'        => 'Gel&ouml;schte Benutzer',
    'no_users'            => 'keine Benutzer',
    'user_add_group'      => 'Neue Gruppe hinzuf&uuml;gen',
    'user_edit_group'     => 'Gruppe bearbeiten',
    'group_name_error'    => 'Eine Gruppe mit diesem Namen existriert bereits. Bitte w&auml;hlen Sie einen anderen Namen.',
    'user_group_add'      => 'Gruppe eintragen',
    'group_default'       => 'Standardgruppe',
    'group_guests'        => 'Gstegruppe', // Umlaute belassen!
    'group_name'          => 'Gruppenname',
    'group_guests_only'   => 'Diese Gruppe ist f&uuml;r G&auml;ste reserviert!',
    'group_rights'        => 'Gruppenrechte',
    'group_delete_error'  => 'Sie k&ouml;nnen die %s nicht l&ouml;schen!',
    'group_delete_text'   => 'Sind Sie sicher, dass die Gruppe "%s" gel&ouml;scht werden soll? Eventuell vorhandene Benutzer werden automatisch der Standardgruppe zugewiesen.', // %s = Gruppenname
    
    // Admin - Benutzer - Rechte
    'auth_view'        => 'Ansicht',
    'auth_add'         => 'Erstellen',
    'auth_editall'     => 'Andere bearbeiten',
    'auth_deleteall'   => 'Andere l&ouml;schen',
    'auth_isdev'       => 'Als Entwickler',
    'auth_adddownload' => 'Neuer Download',
    
    // Admin - Einstellungen
    'configs'                        => 'Einstellungen',
    'config'                         => 'Einstellung',
    'config_info'                    => 'Hier k&ouml;nnen Sie die Einstellungen von pToDo anpassen:',
    'config_save'                    => 'Einstellungen speichern',
    'cfg_sitetitle'                  => 'Seitentitel',
    'cfg_sitetitle_desc'             => 'Hier k&ouml;nnen Sie einen Seitentitel angeben, welcher im Header angezeigt wird.',
    'cfg_sitesubtitle'               => 'Untertitel',
    'cfg_sitesubtitle_desc'          => 'Hier k&ouml;nnen Sie einen Untertitel angeben, welcher unter dem Seitentitel im Header angezeigt wird.',
    'cfg_adminemail'                 => 'Administrator Email',
    'cfg_adminemail_desc'            => 'Diese Email wird als Absenderemail f&uuml;r ausgehende Emails vom System (bspw. f&uuml;r die Benachrichtigung bei abonnierten Eintr&auml;gen) genutzt. Ist diese Einstellung nicht gesetzt, so werden keine Emails verschickt!',
    'cfg_setdonebydev'               => 'Verantwortlicher Entwickler',
    'cfg_setdonebydev_desc'          => 'Hier k&ouml;nnen Sie das Verhalten der Funktionen "abschlie&szlig;en" und "abnehmen" einstellen. Nur der verantwortliche Entwickler hat das Recht einen Eintrag abzunehmen. Sollte er selber einen Eintrag schlie&szlig;en, so wird dieser automatisch abgenommen. Nun k&ouml;nnen Sie w&auml;hlen, ob der Autor des Eintrags, oder der aktuell eingetragene Entwickler als Verantwortlicher angesehen werden soll.',
    'cfg_adddependencebyauthor'      => 'Abh&auml;ngigkeiten ein- / austragen',
    'cfg_adddependencebyauthor_desc' => 'Hier k&ouml;nnen Sie Einstellen wer das Recht hat Abh&auml;ngigkeiten f&uuml;r einen Eintrag zu verwalten. Entweder nur der Autor des Eintrags, oder allgemein alle Autoren und Entwickler.',
    'cfg_itemauthor'                 => 'Autor des Eintrags',
    'cfg_authordevs'                 => 'Autoren und Entwickler',
    'cfg_forcecomments'              => 'Kommentare erzwingen',
    'cfg_forcecomments_desc'         => 'Hier k&ouml;nnen Sie Einstellen bei welchen Aktionen auf jeden Fall ein Kommentar abgegeben werden muss.',
    'cfg_force_setdev'               => 'Entwickler Ein- / Austragen',
    'cfg_force_done'                 => 'Eintrag abnehmen',
    'cfg_force_openclose'            => 'Eintrag &ouml;ffnen / schlie&szlig;en',
    'cfg_naviboxwidth'               => 'Breite der linken Navigationsbox (in Pixeln)',
    'cfg_naviboxwidth_desc'          => 'Hier k&ouml;nnen Sie die Breite der linken Navigationsbox in Pixeln (Standard 100) einstellen.',
    'cfg_lastitemscount'             => 'Anzahl der Eintr&auml;ge in der bersicht',
    'cfg_lastitemscount_desc'        => 'Hier k&ouml;nnen Sie die Anzahl der Eintr&auml;ge angeben (Standard 10), welche pro Status in der &Uuml;bersicht aufgelistet werden.',
    'cfg_itemsperpage'               => 'Anzahl der Eintr&auml;ge pro Seite',
    'cfg_itemsperpage_desc'          => 'Hier k&ouml;nnen Sie die Anzahl der Eintr&auml;ge pro Seite angeben (Standard 25), welche bei Auflistungen angezeigt werden sollen.',
    'cfg_fileuploaddir'              => 'Ordner f&uuml;r Dateiuploads',
    'cfg_fileuploaddir_desc'         => 'Hier k&ouml;nnen Sie den Ordner angeben, welcher f&uuml;r Dateiuploads genutzt werden soll. Die Angabe ist relativ zur index.php von pToDo und der Ordner muss Schreibrechte besitzen.',
    'cfg_fileuploadexts'             => 'Erlaubte Dateitypen f&uuml;r Dateiuploads',
    'cfg_fileuploadexts_desc'        => 'Hier k&ouml;nnen Sie alle erlaubten Dateitypen f&uuml;r den Dateiupload angeben. Einzelne Dateiendungen m&uuml;ssen durch ein Komma getrennt werden. Lassen Sie das Feld leer, wenn Sie alle Dateitypen erlauben wollen.',
    'cfg_fileuploadmaxsize'          => 'Maximale Dateigr&ouml;&szlig;e f&uuml;r Dateiuploads (in Bytes)',
    'cfg_fileuploadmaxsize_desc'     => 'Hier k&ouml;nnen Sie die maximale Dateigr&ouml;&szlig;e f&uuml;r Dateiuploads in Bytes angeben (Standard 102400 = 100Kb). Setzen Sie den Wert auf 0 um Dateien jeder Gr&ouml;&szlig;e zu erlauben.',
    'cfg_guestmode'                  => 'G&auml;stemodus aktivieren',
    'cfg_guestmode_desc'             => 'Hier k&ouml;nnen Sie den G&auml;stemodus aktivieren. In diesem haben auch nicht eingeloggte Benutzer die M&ouml;glichkeit auf das System zuzugreifen. &Uuml;ber die Benutzergruppe "G&auml;stegruppe" k&ouml;nnen Sie dir Rechte f&uuml;r G&auml;ste einstellen.',
    'cfg_typeprefixother'            => 'Changelogprefix f&uuml;r den Typ "Sonstiges"',
    'cfg_typeprefixother_desc'       => 'Hier knnen Sie einen Prefix fr den Eintragstypen "Sonstiges" angeben, welcher als Standardwert im Changelog Generator angezeigt wird.',
    'cfg_typeprefixfeature'          => 'Changelogprefix f&uuml;r den Typ "Feature"',
    'cfg_typeprefixfeature_desc'     => 'Hier knnen Sie einen Prefix fr den Eintragstypen "Feature" angeben, welcher als Standardwert im Changelog Generator angezeigt wird.',
    'cfg_typeprefixbugfix'           => 'Changelogprefix f&uuml;r den Typ "Bugfix"',
    'cfg_typeprefixbugfix_desc'      => 'Hier knnen Sie einen Prefix fr den Eintragstypen "Bugfix" angeben, welcher als Standardwert im Changelog Generator angezeigt wird.',

    // Admin - Speicherplatz
    'space'        => 'Speicherplatz',
    'space_info'   => 'Hier k&ouml;nnen Sie sehen wie viel Speicherplatz pToDo mit seinen Daten verbraucht.',
    'space_web'    => 'Webspace',
    'space_db'     => 'Datenbank',
    'space_script' => 'pToDo Script',
    'space_upload' => 'Dateiuploads',

    // Admin - Updatecheck
    'update'              => 'Updatecheck',
    'update_version_ok1'  => 'Ihre Version %s von pToDo ist auf dem aktuellsten Stand!', // %s = Versionsnummer
    'update_version_ok2'  => 'Es ist momentan keine neuere Version verf&uuml;gbar.',
    'update_version_old1' => 'Ihre Version %s von pToDo ist <b>nicht</b> auf dem neusten Stand!', // %s = Versionsnummer
    'update_version_old2' => 'Sie sollten die neue Version %s herunterladen und installieren', // %s = Versionsnummer
    'update_download'     => 'Downloadseite &ouml;ffnen',
    'update_server_error' => 'Konnte keine Verbindung zum pr0g.net Server herstellen, gemeldeter Fehler',
    'update_socket_error' => 'Konnte keinen Socket &ouml;ffnen.',
    
    // Useradmin
    'uadministration' => 'Useradministration',
    'uadmin_text'     => 'Bitte w&auml;hlen Sie einen Administrationspunkt aus der linken Auflistung.',
    'uadmin_open'     => 'Bei folgenden offenen Eintrgen sind Sie als Entwickler eingetragen',
    
    // Useradmin - Password
    'password_changed' => 'Das Passwort wurde ge&auml;ndert!',
    'password_text'    => 'Hier k&ouml;nnen Sie ein neues Passwort f&uuml;r Ihren Account festlegen',
    'password_new'     => 'Neues Passwort',
    'password_change'  => 'Passwort &auml;ndern',
    
    // Useradmin - E-Mail
    'email_changed' => 'Die E-Mail wurde ge&auml;ndert!',
    'email_text'    => 'Hier k&ouml;nnen Sie ihre E-Mailadresse &auml;ndern. Diese wird genutzt um ihnen eine Nachricht zukommen zu lassen, wenn eine &Auml;nderung bei einem abonnierten Eintrag stattgefunden hat',
    'email_change'  => 'E-Mail &auml;ndern',
    
    // E-Mailbenachrichtigung
    'email_notify_text'    => "nderungsinformation von pToDo auf %host:\n\nEintrag:      #%id - %title\nZeitpunkt:    %time\nAnderungstyp: %action\nKommentar:    %comment\n\nZum Eintrag: http://%link", // %host = Host, %id = Eintragsid, %title = Eintragstitel, %time = nderungszeitpunkt, %action = nderungstyp, %comment = Kommentar, %link = Direktlink
    'email_notify_subject' => 'nderungsinformation von pToDo',
  );

  // Hilfetexte
  $help_data = array(
    array('title' => 'Index',
          'admin' => false,
          'text' => '
<h1>Willkommen</h1>
<br />
Dies ist die Hilfe zu <b>pToDo</b>, dem ToDo-Listen Manager. Die Hilfe ist in verschiedenen Abschnitte gegliedert, bitte w&auml;hlen Sie ein Thema aus der linken Navigation.
'),
    array('title' => 'Interface',
          'admin' => false,
          'text' => '
<h1>Das Interface</h1>
<br />
Das Interface ist in <b>f&uuml;nf Abschnitte</b> aufgeteilt. Oben befindet sich der <b>Header</b>, in welchem ein Seiten- und Untertitel angezeigt werden kann, sowie rechts oben ein Quickjump (Accesskey [Q]) eingeblendet wird. Dort k&ouml;nnen Sie direkt eine Eintragsid eingeben und zu dem Eintrag springen. Links befindet sich die Hauptnavigation (auch <b>Navigation</b> genannt). Rechts daneben ist die Unternavigation (auch <b>Headnavi</b> genannt). Darunter befindet sich der Haupt- oder <b>Inhaltsteile</b>, gefolgt vom <b>Fu&szlig;teil</b> mit Versions- und Copyrightinformationen.<br />
<br />
Die wichtigsten drei Bereiche sind die <b>Navigation</b>, <b>Headnavi</b> und <b>Inhaltsteil</b>.<br />
<br />
Je nach Sektion werden in der <b>Navigation</b> verschiedenen Eintr&auml;ge angezeigt, welche zu einer Unterseite f&uuml;hren. Zu manchen Eintr&auml;gen sind weitere Optionen m&ouml;glich, welche im linken Bereich der <b>Headnavi</b> angezeigt werden. Der rechte Bereich dagegen ist f&uuml;r allgemeine Funktionen, wie Administration, Hilfe und Ausloggen reserviert.
'),
    array('title' => 'ToDo-Liste',
          'admin' => false,
          'text' => '
<h1>Die ToDo-Liste</h1>
<br />
Die ToDo-Listen sind das Kernst&uuml;ck des Systems und in einzelne Sektionen aufgeteilt, welche nachfolgend erl&auml;utert werden:<br />
<br />
<h1>&Uuml;bersicht</h1>
<br />
In der &Uuml;bersicht k&ouml;nnen der aktuelle Projektstatus und die letzten zehn Eintr&auml;ge in einem Breich eingesehen werden. Die Eintr&auml;ge werden folgenden drei Bereichen zugeordnet:<br />
<br />
<div class="div_index_open"><span class="span_index_title">Offene Eintr&auml;ge</span></div>
<br />
Als offen werden alle noch nicht abgeschlossenen Aufgaben bezeichnet.<br />
<br />
<div class="div_index_close"><span class="span_index_title">Geschlossene Eintr&auml;ge</span></div>
<br />
Als geschlossen werden alle Aufgaben bezeichnet, die von einem anderen Entwickler als dem verantwortlichem Entwickler abgeschlossen wurden. Nun hat der verantwortliche Entwickler nochmal die M&ouml;glichkeit den Punkt zu kontrollieren, bevor er ihn endg&uuml;ltig abschlie&szlig;t.<br />
<br />
<div class="div_index_done"><span class="span_index_title">Abgenommene Eintr&auml;ge</span></div>
<br />
Als abgenommen werden alle Aufgaben bezeichnet, welche vom verantwortlichen Entwickler endg&uuml;ltig abgeschlossen wurden.<br />
<br />
<br />
Als verantwortlicher Entwickler f&uuml;r eine Eintrag gilt der %setdone%.<br />
<br />
Auf der linken Seite steht die Id des Eintrags, diese ist je nach Priorit&auml;t mit einer anderen Farbe hinterlegt. Daneben steht Name des zugewiesenen Entwicklers. Wurde dem Punkt noch kein Entwickler zugewiesen, so wird ein Platzhalter (---) angezeigt. Haben Sie sich eingeloggt, so wird ihr Benutzername vor den Eintr&auml;gen blau dargestellt, damit Sie ihre Eintr&auml;ge sofort &uuml;berblicken k&ouml;nnen. Zuletzt kommt der Titel.<br />
<br />
In der Headnavi sind nun weitere Optionen verf&uuml;gbar. &Uuml;ber die Links "offene", "geschlossene", "abgenommene" und "unzugeordnete" gelangen Sie in eine Teilliste, welche nur die jeweiligen Eintr&auml;ge des Bereichs beinhalten. Unter "unzugeordnete" werden alle Eintr&auml;ge angezeigt, welche keinen zugewiesenen Entwickler haben, dabei wird der Status nicht beachtet. Am Anfang der Liste finden Sie eine Auswahl m&ouml;glicher Sortierungsoptionen.<br />
<br />
Folgende Priorit&auml;ten kann ein Eintrag haben:<br />
<br />
<span class="priority_veryhigh">&nbsp;&nbsp;</span> - sehr hoch<br />
<span class="priority_high">&nbsp;&nbsp;</span> - hoch<br />
<span class="priority_normal">&nbsp;&nbsp;</span> - normal<br />
<span class="priority_low">&nbsp;&nbsp;</span> - niedrig<br />
<span class="priority_verylow">&nbsp;&nbsp;</span> - sehr niedrig<br />
<br />
<h1>Eintragsansicht</h1>
<br />
In der Eintragsansicht werden alle Informationen zu einem Eintrag angezeigt. Unten befindet sich eine History, welche alle Aktionen die an dem Eintrag ausgef&uuml;hrt wurden dokumentiert. In der Headnavi werden nun bei entsprechenden Rechten die Optionen "Bearbeiten" und "L&ouml;schen" eingeblendet. Ist der Eintrag von anderen Eintr&auml;gen abh&auml;ngig, so werden diese in einer Liste dargestellt, wobei die Id je nach Status des Eintrags (offen, geschlossen oder abgenommen) mit der entsprechenden Statusfarbe hinterlegt ist. Ist der Eintrag selber als Abh&auml;ngigkeit eines anderen Eintrags eingetragen, so wird darunter eine Auflistung aller Eintr&auml;ge angezeigt, in welchen dieser Eintrag eingetragen wurde. Die Liste ist nach Priorit&auml;ten sortiert und die Ids sind je nach Priorit&auml;t mit der entprechenden Farbe hinterlegt.<br />
<br />
<h1>Abonnements</h1>
<br />
Sie k&ouml;nnen Eintr&auml;ge direkt beim Erstellen, oder nachtr&auml;glich &uuml;ber die Eintragsansicht abonnieren. Wird an einem abonnierten Eintrag von jemand anderem etwas ver&auml;ndert, bzw. eine Aktion durchgef&uuml;hrt, so werden Sie automatisch per E-Mail dar&uuml;ber informiert. Dies ist nur m&ouml;glich, wenn Sie in der Useradmin eine g&uuml;ltige E-Mailadresse angegeben haben!
'),
    array('title' => 'Useradmin',
          'admin' => false,
          'text' => '
<h1>Die Useradmin</h1>
<br />
Auf die eigene Useradmin hat jeder Benutzer Zugriff und sie erm&ouml;glicht das Setzen eines neues Passworts f&uuml;r den Zugriff auf das System sowie einer Email, welche f&uuml;r das Abonnieren von Eintr&auml;gen ben&ouml;tigt wird.
'),
    array('title' => 'A: Navigation',
          'admin' => true,
          'text' => '
<h1>Administration - Navigation</h1>
<br />
ber den Navigationseditor knnen Sie neue Bereiche auf der Seite anlegen, diese werden dann in der Navigation eingeblendet.<br />
<br />
Folgende Eintragstypen stehen zur Auswahl:<br />
<br />
<b>Gruppe:</b> Eine Gruppe kann mehrere Bereiche zusammenfassen und ffnet sich im Men, sobald sie ausgewhlt ist, oder ein Untereintrag aktiv wird. Einer Gruppe selber kann keine weitere Gruppe als Untereintrag zugewiesen werden.<br />
<br />
<b>Weblink:</b> Ein Weblink ist eine normaler Link zu einer anderen Webseite, welche per URL angegeben werden kann. Dabei lsst sich auswhlen wie der Link geffnet werden soll.<br />
<br />
<b>HTML Seite:</b> Bei der HTML Seite kann direkt in der Navigation der Code fr die Seite eingetragen werden. Diese wird dann bei Auswahl im Inhalts-Bereich angezeigt.<br />
<br />
<b>ToDo-Liste:</b> Das Kernstck des Systems, eine ToDo-Liste zur Verwaltung von Aufgaben fr ein Projekt.<br />
<br />
<b>Forum:</b> Das Forum kann fr Diskussionen zu einem Projekt genutzt werden.
'),
    array('title' => 'A: Benutzer',
          'admin' => true,
          'text' => '
<h1>Administration - Benutzer</h1>
<br />
Im Benutzerbereich k&ouml;nnen Sie einzelne Benutzer und Benutzergruppen anlegen, sowie den Benutzergruppen verschiedenen Rechte zuweisen.<br />
<br />
Es gibt zwei feste Benutzergruppen, welche nicht gel&ouml;scht werden k&ouml;nnen. Dies sind:<br />
<br />
<b>Standardgruppe:</b> Neue Benutzer werden automatisch dieser Gruppe zugewiesen.<br />
<br />
<b>G&auml;stegruppe:</b> Ist der Gastmodus aktiv, so wird diese Gruppe genutzt um die entsprechenden Rechte des Gastusers zu verwalten. Der Gruppe k&ouml;nnen keine registrierten Benutzer zugewiesen werden und sie ist auf Leserechte (Allgemein, History und Download) beschr&auml;nkt.<br />
<br />
<br />
Nachfolgend eine Beschreibung der einzelnen Rechte:<br />
<br />
<b>Ansicht:</b> Ist dieses Recht gesetzt, so darf der Benutzer den Bereich ansehen.<br />
<br />
<b>Erstellen:</b> Ist dieses Recht gesetzt, so darf der Benutzer bei einer ToDo-Liste neue Eintr&auml;ge, bzw. bei einem Forum neue Themen erstellen und auf vorhandenen Antworten.<br />
<br />
<b>Bearbeiten:</b> Ist dieses Recht gesetzt, so darf der Benutzer seine eigenen Eintr&auml;ge in einer ToDo-Liste, bzw. Beitr&auml;ge in einem Forum bearbeiten.<br />
<br />
<b>Andere Bearbeiten:</b> Ist dieses Recht gesetzt, so darf der Benutzer die Eintr&auml;ge in einer ToDo-Liste, bzw. Beitr&auml;ge in einem Forum von anderen Benutzern bearbeiten.<br />
<br />
<b>L&ouml;schen:</b> Ist dieses Recht gesetzt, so darf der Benutzer seine eigenen Eintr&auml;ge in einer ToDo-Liste l&ouml;schen.<br />
<br />
<b>Andere L&ouml;schen:</b> Ist dieses Recht gesetzt, so darf der Benutzer die Eintr&auml;ge von anderen Benutzern in einer ToDo-Liste l&ouml;schen.<br />
<br />
<b>Als Entwickler:</b> Ist dieses Recht gesetzt, so darf der Benutzer als Entwickler in einer ToDo-Liste t&auml;tig sein.<br />
<br />
<b>History:</b> Ist dieses Recht gesetzt, so darf der Benutzer die History von Eintr&auml;gen in einer ToDo-Liste einsehen. Damit verbunden ist auch das Abonnieren von Eintr&auml;gen.<br />
<br />
<b>Download:</b> Ist dieses Recht gesetzt, so darf der Benutzer angehangene Dateien in Eintr&auml;gen einer ToDo-Liste herunterladen.<br />
<br />
<b>Neuer Download:</b> Ist dieses Recht gesetzt, so darf der Benutzer selber Dateien an Eintr&auml;ge einer ToDo-Liste anh&auml;ngen und seine eigenen l&ouml;schen.<br />
<br />
<br />
Nich jeder Aktion ist ein eigenes Recht zugeordnet, so werden f&uuml;r manche Aktionen auch Kombinatioen verschiedener Rechte genutzt. Ein Kommentar zu einem Eintrag in einer ToDo-Liste kann etwa nur geschrieben werden, wenn der Benutzer das Recht hat die History einzusehen und neue Eintr&auml;ge hinzuf&uuml;gen darf, oder als Entwickler t&auml;tig ist.
')
  );

$help_data[2]['text'] = str_replace('%setdone%', ($cfg['setdone_bydev'] ? 'aktuell eingetragene Entwickler' : 'Autor des Eintrags'), $help_data[2]['text']);
?>