<?php
/*-----------------------------------------------------------------------------
  pToDo - Konstanten
  ------------------
  Im Script genutze Konstanten
  ----------------------------
  Lizenz:

    Copyright (C) 2005 - 2006 Andreas "Pr0g" Droesch

    pToDo ist Freeware und darf ausdrcklich weitergegeben werden, sofern
    dies kostenlos und in unvernderter Form des Scripts geschieht.

    Der Autor haftet nicht fr Schden, die durch die Nutzung dieses Scripts
    entstanden sind!
  -----------------------------------------------------------------------------
  Author:

    Andreas "Pr0g" Droesch
    http://pr0g.net,
    webmaster@pr0g.net
    All Rights reserved.

  Version:

    siehe index.php
-----------------------------------------------------------------------------*/

  /////////////////////////////////////////////////////////////////////////
  //                                                                     //
  //  WICHTIG: nderungen von Werten in dieser Datei knnen die Sicher-  //
  //           heit des Scripts beeintrchtigen!                         //
  //                                                                     //
  /////////////////////////////////////////////////////////////////////////

  // Benutzerrechte
  define('AUTH_VIEW', 1); // Ansicht
  define('AUTH_ADD', 2); // Erstellen
  define('AUTH_EDIT', 4); // Bearbeiten (eigene Eintrge)
  define('AUTH_EDIT_ALL', 8); // Bearbeiten (fremde Eintrge)
  define('AUTH_DELETE', 16); // Lschen (eigene Eintrge)
  define('AUTH_DELETE_ALL', 32); // Lschen (fremde Eintrge)
  define('AUTH_ISDEV', 64); // Als Entwickler ttig
  define('AUTH_VIEW_HISTORY', 128); // History ansehen
  define('AUTH_VIEW_DOWNLOAD', 256); // Download hinzufgen
  define('AUTH_ADD_DOWNLOAD', 1024); // Download ansehen
  
  // Zwangskommentare
  define('COMMENT_SETDEV', 1); // Entwickler Ein- / Austragen
  define('COMMENT_EDIT', 2); // Eintrag bearbeiten
  define('COMMENT_OPENCLOSE', 4); // Eintrag ffnen / abschlieen
  define('COMMENT_DONE', 8); // Eintrag abnehmen

  // History Aktionen
  define('HISTORY_EDIT', 1); // Item bearbeiten
  define('HISTORY_CLOSE', 2); // Item schlieen
  define('HISTORY_OPEN', 3); // Item ffnen
  define('HISTORY_DONE', 4); // Item abnehmen
  define('HISTORY_SETDEV', 5); // Entwickler fr Item eintragen
  define('HISTORY_UNSETDEV', 6); // Entwickler fr Item austragen
  define('HISTORY_COMMENT', 7); // Kommentar schreiben
  define('HISTORY_FILEADD', 8); // Datei hochgeladen
  define('HISTORY_FILEDELETE', 9); // Datei gelscht
  define('HISTORY_DEPENDENCEADD', 10); // Abhngigkeit eintragen
  define('HISTORY_DEPENDENCEDELETE', 11); // Abhngigkeit austragen

  // Itemstatus
  define('STATUS_OPEN', 1); // Iten offen
  define('STATUS_CLOSE', 2); // Item geschlossen
  define('STATUS_DONE', 3); // Item abgenommen
  define('STATUS_NODEV', 4); // Kein Entwickler zugeordnet
  
  // Itemtypen
  define('TYPE_OTHER', 1); // Sonstiges
  define('TYPE_FEATURE', 2); // Feature
  define('TYPE_BUGFIX', 3); // Bugfix

  // Suchorte
  define('SEARCH_TITLE', 1); // Titel
  define('SEARCH_TEXT', 2); // Beschreibung
  define('SEARCH_TITLETEXT', 3); // Titel & Beschreibung

  // Sortierung
  define('SORT_ID', 1); // Id / Datum
  define('SORT_ENDDATE', 2); // Enddatum
  define('SORT_TITLE', 3); // Titel
  define('SORT_PRIORITY', 4); // Prioritt
  define('SORT_TYPE', 5); // Typ

  // Sortierungsreihenfolge
  define('SORT_ORDER_DESC', 1); // Absteigend
  define('SORT_ORDER_ASC', 2); // Aufsteigend

  // Navigationstypen
  define('NAVITEM_GROUP', 1); // Gruppe
  define('NAVITEM_LINK', 2); // Link
  define('NAVITEM_HTML', 3); // HTML Seite
  define('NAVITEM_TODO', 4); // ToDo-Liste
  define('NAVITEM_FORUM', 5); // Forum

  // Prioritten
  define('PRIORITY_VERYLOW', 1); // Sehr niedrig
  define('PRIORITY_LOW', 2); // Niedrig
  define('PRIORITY_NORMAL', 3); // Normal
  define('PRIORITY_HIGH', 4); // Hoch
  define('PRIORITY_VERYHIGH', 5); // Sehr hoch
  
  // Standardgruppen Ids
  define('GROUP_DEFAULT', 1); // Standardgruppe fr neue User
  define('GROUP_GUESTS', 2); // Gruppe fr Gste
  
  // Ziel fr Linkitems
  define('LINKTARGET_SELF', 1); // Im gleichen Fenster anzeigen
  define('LINKTARGET_FRAME', 2); // Im Inhaltsbereich anzeigen
  define('LINKTARGET_NEW', 3); // Im neuen Fenster anzeigen
  
  // Tabellennamen
  define('TABLE_CONFIG', $tbl_prefix . 'config'); // Konfiguration
  define('TABLE_FILES', $tbl_prefix . 'files'); // Dateien
  define('TABLE_GROUPS', $tbl_prefix . 'groups'); // Benutzergruppen
  define('TABLE_HISTORY', $tbl_prefix . 'history'); // History / Log
  define('TABLE_ITEMLINK', $tbl_prefix . 'itemlink'); // Abhngigkeiten der Eintrge
  define('TABLE_ITEMS', $tbl_prefix . 'items'); // Eintrge
  define('TABLE_ITEMWATCH', $tbl_prefix . 'itemwatch'); // Abonnierte Eintrge
  define('TABLE_NAVITEMS', $tbl_prefix . 'navitems'); // Navigationsitems
  define('TABLE_POSTS', $tbl_prefix . 'posts'); // Foreneintrge
  define('TABLE_RIGHTS', $tbl_prefix . 'rights'); // Gruppenrechte
  define('TABLE_USERS', $tbl_prefix . 'users'); // Benutzerdaten
  define('TABLE_VERSIONS', $tbl_prefix . 'versions'); // Projektversionen
?>