<?php
/*-----------------------------------------------------------------------------
  pToDo - Eintrge Modul
  ----------------------
  Verarbeitung der Eintrge
  -------------------------
  Lizenz:

    Copyright (C) 2005 - 2006 Andreas "Pr0g" Droesch

    pToDo ist Freeware und darf ausdrcklich weitergegeben werden, sofern
    dies kostenlos und in unvernderter Form des Scripts geschieht.

    Der Autor haftet nicht fr Schden, die durch die Nutzung dieses Scripts
    entstanden sind!
  -----------------------------------------------------------------------------
  Author:

    Andreas "Pr0g" Droesch
    http://pr0g.net,
    webmaster@pr0g.net
    All Rights reserved.

  Version:

    siehe index.php
-----------------------------------------------------------------------------*/

  // Sicherheitsschutz
  if (!defined('IN_PTODO')) {
    die;
  }

  // Integer validieren
  if (isset($_GET['id'])) {
    $_GET['id'] = (int)$_GET['id'];
  }

  // BBCodes einbinden
  include('bbcode.php');

  // Dateierweiterung ermitteln
  function GetFileExt($file) {
    $dotpos = strrpos($file, '.');
    if ($dotpos === false) {
      return false;
    }
    return strtolower(substr($file, $dotpos + 1, strlen($file) - $dotpos - 1));
  }

  // Prft ob ein Kommentar angegeben werden muss und wurde
  function ForceComments($comment, $auth) {
    global $cfg;
    if ($cfg['force_comments'] & $auth) {
      return (!empty($comment));
    } else {
      return true;
    }
  }

  $sql = 'SELECT COUNT(item_id) AS ItemsCount FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
  $query = @mysql_query($sql);
  $row = @mysql_fetch_array($query);
  if ($row['ItemsCount'] == 0) {
    ShowError(str_replace('%s', $_GET['id'], $lang['item_error']));
  } else {
    // Rechte prfen
    if (!UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_VIEW)) {
      ShowError($lang['auth_item_error']);
    } else {
      if ($_GET['action'] == 'subscribe') { // Eintrag abonnieren
        // Rechte prfen
        if (!UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_VIEW_HISTORY)) {
          ShowError($lang['auth_item_sub_error']);
        } else {
          $sql = 'SELECT COUNT(user_id) AS UserCount FROM ' . TABLE_ITEMWATCH . ' WHERE user_id=' . $_SESSION['ptodo_user_id'] . ' AND item_id=' . $_GET['id'];
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          if ($row['UserCount'] == 0) {
            $sql = 'INSERT INTO ' . TABLE_ITEMWATCH . ' (user_id, item_id) VALUES (' . $_SESSION['ptodo_user_id'] . ', ' . $_GET['id'] . ')';
          } else {
            $sql = 'DELETE FROM ' . TABLE_ITEMWATCH . ' WHERE user_id=' . $_SESSION['ptodo_user_id'] . ' AND item_id=' . $_GET['id'];
          }
          @mysql_query($sql);
          header('location: ?id=' . $_GET['id']);
        }
      } elseif ($_GET['action'] == 'change_dev') { // Entwickler ein- / austragen
        // Rechte prfen
        if (!UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ISDEV)) {
          ShowError($lang['auth_item_dev_error']);
        } else {
          if (isset($_POST['send']) && ForceComments($_POST['comment'], COMMENT_SETDEV)) {
            $sql = 'SELECT developer_id FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
            if ($row['developer_id'] == 0) {
              $newdev = $_SESSION['ptodo_user_id'];
              $dev_action = HISTORY_SETDEV;
            } elseif ($row['developer_id'] == $_SESSION['ptodo_user_id']) {
              $newdev = 0;
              $dev_action = HISTORY_UNSETDEV;
            }
            $sql = 'UPDATE ' . TABLE_ITEMS . ' SET developer_id=' . $newdev . ' WHERE item_id=' . $_GET['id'];
            @mysql_query($sql);
            AddHistoryItem($_GET['id'], $dev_action, $_POST['comment']);
            header('location: ?id=' . $_GET['id']);
          } else {
            $notice = $lang['notice'] . ': ' . ($cfg['force_comments'] & COMMENT_SETDEV ? $lang['comment_force'] : $lang['comment_optional']);
            if (isset($_POST['send'])) {
              $notice = '<span class="info_warning">' . $notice . '</span>';
            }
?>
<form action="?id=<?php echo $_GET['id']; ?>&amp;action=change_dev" method="post">
<?php echo $lang['comment']; ?>:<br />
<?php echo GetBBCodePanel('ta_comment'); ?><br />
<textarea name="comment" class="textarea_todo_comment" id="ta_comment"></textarea><br />
<?php echo $notice; ?><br />
<br />
<input type="submit" name="send" accesskey="s" value="<?php echo $lang['send']; ?>" />
</form>
<?php
          }
        }
      } elseif ($_GET['action'] == 'change_done') { // Eintrag ffnen / abschlieen
        // Rechte prfen
        if (!UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ISDEV)) {
          ShowError($lang['auth_item_dev_error']);
        } else {
          if (isset($_POST['send']) && ForceComments($_POST['comment'], COMMENT_OPENCLOSE)) {
            $setdone = ($cfg['setdone_bydev'] ? 'developer_id' : 'item_author');
            $sql = 'SELECT item_endtime, ' . $setdone . ' FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
            if ($row['item_endtime'] == 0) {
              $newtime = time();
              $done = ($row[$setdone] == $_SESSION['ptodo_user_id'] ? 1 : 0);
              $dev_action = HISTORY_CLOSE;
            } else {
              $newtime = 0;
              $done = 0;
              $dev_action = HISTORY_OPEN;
            }
            $sql = 'UPDATE ' . TABLE_ITEMS . ' SET item_endtime=' . $newtime . ', item_done=' . $done . ' WHERE item_id=' . $_GET['id'];
            @mysql_query($sql);
            AddHistoryItem($_GET['id'], $dev_action, $_POST['comment']);
            header('location: ?id=' . $_GET['id']);
          } else {
            $notice = $lang['notice'] . ': ' . ($cfg['force_comments'] & COMMENT_OPENCLOSE ? $lang['comment_force'] : $lang['comment_optional']);
            if (isset($_POST['send'])) {
              $notice = '<span class="info_warning">' . $notice . '</span>';
            }
?>
<form action="?id=<?php echo $_GET['id']; ?>&amp;action=change_done" method="post">
<?php echo $lang['comment']; ?>:<br />
<?php echo GetBBCodePanel('ta_comment'); ?><br />
<textarea name="comment" class="textarea_todo_comment" id="ta_comment"></textarea><br />
<?php echo $notice; ?><br />
<br />
<input type="submit" name="send" accesskey="s" value="<?php echo $lang['send']; ?>" />
</form>
<?php
          }
        }
      } elseif ($_GET['action'] == 'change_done_end') { // Eintrag komplett abschlieen
        // Rechte prfen
        if (!UserAuth($_SESSION['ptodo_user_id'], $todo_id, ($cfg['setdone_bydev'] ? AUTH_ISDEV : AUTH_ADD))) {
          ShowError($lang['auth_item_dev_error']);
        } else {
          $setdone = ($cfg['setdone_bydev'] ? 'developer_id' : 'item_author');
          $sql = 'SELECT item_done FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'] . ' AND ' . $setdone . '=' . $_SESSION['ptodo_user_id'];
          $query = @mysql_query($sql);
          if (@mysql_num_rows($query) == 0) {
            ShowError(str_replace('%s', $_GET['id'], $lang['close_error']));
          } else {
            if (isset($_POST['send']) && ForceComments($_POST['comment'], COMMENT_DONE)) {
              $sql = 'UPDATE ' . TABLE_ITEMS . ' SET item_done=1 WHERE item_id=' . $_GET['id'];
              @mysql_query($sql);
              AddHistoryItem($_GET['id'], HISTORY_DONE, $_POST['comment']);
              header('location: ?id=' . $_GET['id']);
            } else {
              $notice = $lang['notice'] . ': ' . ($cfg['force_comments'] & COMMENT_DONE ? $lang['comment_force'] : $lang['comment_optional']);
              if (isset($_POST['send'])) {
                $notice = '<span class="info_warning">' . $notice . '</span>';
              }
?>
<form action="?id=<?php echo $_GET['id']; ?>&amp;action=change_done_end" method="post">
<?php echo $lang['comment']; ?>:<br />
<?php echo GetBBCodePanel('ta_comment'); ?><br />
<textarea name="comment" class="textarea_todo_comment" id="ta_comment"></textarea><br />
<?php echo $notice; ?><br />
<br />
<input type="submit" name="send" accesskey="s" value="<?php echo $lang['send']; ?>" />
</form>
<?php
            }
          }
        }
      } elseif ($_GET['action'] == 'dependence_add') { // Abhngigkeit eintragen
        // Rechte prfen
        if (!UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD | AUTH_ISDEV)) {
          ShowError($lang['auth_item_dev_error']);
        } else {
          if ($cfg['adddependence_byauthor']) {
            $sql = 'SELECT item_author FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
            if ($row['item_author'] !== $_SESSION['ptodo_user_id']) {
              header('location: ?id=' . $_GET['id']);
              die;
            }
          }
          if (!empty($_POST['item_id']) && !isset($_POST['show_title'])) {
            if ($_POST['item_id'] == $_GET['id']) {
              ShowError($lang['item_selfdepend_error'] . '<br /><br /><a href="?id=' . $_GET['id'] . '&amp;action=dependence_add">' . $lang['back'] . '</a>');
            } else {
              $sql = 'SELECT COUNT(item_id) AS ItemCount FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_POST['item_id'];
              $query = @mysql_query($sql);
              $row = @mysql_fetch_array($query);
              if ($row['ItemCount'] > 0) {
                $sql = 'SELECT COUNT(item_id) AS ItemCount FROM ' . TABLE_ITEMLINK . ' WHERE linkitem_id=' . $_POST['item_id'] . ' AND item_id=' . $_GET['id'];
                $query = @mysql_query($sql);
                $row = @mysql_fetch_array($query);
                if ($row['ItemCount'] == 0) {
                  $sql = 'INSERT INTO ' . TABLE_ITEMLINK . ' (item_id, linkitem_id) VALUES (' . $_GET['id'] . ', ' . $_POST['item_id'] . ')';
                  @mysql_query($sql);
                  AddHistoryItem($_GET['id'], HISTORY_DEPENDENCEADD, $_POST['item_id']);
                  header('location: ?id=' . $_GET['id']);
                } else {
                  ShowError(str_replace('%s', $_POST['item_id'], $lang['linkitem_error']) . '<br /><br /><a href="?id=' . $_GET['id'] . '&amp;action=dependence_add">' . $lang['back'] . '</a>');
                }
              } else {
                ShowError(str_replace('%s', $_POST['item_id'], $lang['item_error']) . '<br /><br /><a href="?id=' . $_GET['id'] . '&amp;action=dependence_add">' . $lang['back'] . '</a>');
              }
            }
          } else {
?>
<form action="?id=<?php echo $_GET['id']; ?>&amp;action=dependence_add" method="post">
<?php echo $lang['id']; ?>: <input type="text" name="item_id" value="<?php echo (isset($_POST['item_id']) ? $_POST['item_id'] : ''); ?>" /> <input type="submit" name="show_title" value="<?php echo $lang['show_title']; ?>" /><br />
<br />
<?php
            if (isset($_POST['show_title'])) {
              $sql = 'SELECT item_title FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_POST['item_id'];
              $query = @mysql_query($sql);
              if (@mysql_num_rows($query) == 0) {
                echo $lang['invalid_id'];
              } else {
                $row = @mysql_fetch_array($query);
                echo $lang['title'] . ': ' . HtmlEnt($row['item_title']);
              }
              echo '<br /><br />';
            }
?>
<input type="submit" accesskey="s" value="<?php echo $lang['add']; ?>" />
</form>
<?php
          }
        }
      } elseif ($_GET['action'] == 'dependence_remove') { // Abhngigkeit austragen
        // Rechte prfen
        if (!UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ISDEV)) {
          ShowError($lang['auth_item_dev_error']);
        } else {
          $allow = true;
          if ($cfg['adddependence_byauthor']) {
            $sql = 'SELECT item_author FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
            $allow = ($row['item_author'] == $_SESSION['ptodo_user_id']);
          }
          if ($allow) {
            $sql = 'SELECT COUNT(item_id) AS ItemCount FROM ' . TABLE_ITEMLINK . ' WHERE item_id=' . $_GET['id'] . ' AND linkitem_id=' . (int)$_GET['item'];
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
            if ($row['ItemCount'] > 0) {
              $sql = 'DELETE FROM ' . TABLE_ITEMLINK . ' WHERE item_id=' . $_GET['id'] . ' AND linkitem_id=' . (int)$_GET['item'];
              @mysql_query($sql);
              AddHistoryItem($_GET['id'], HISTORY_DEPENDENCEDELETE, $_GET['item']);
            }
          }
          header('location: ?id=' . $_GET['id']);
        }
      } elseif ($_GET['action'] == 'comment') { // Kommentar schreiben
        // Rechte prfen
        if (!(UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_VIEW_HISTORY) && UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD | AUTH_ISDEV))) {
          ShowError($lang['auth_item_com_error']);
        } else {
          if (!empty($_POST['comment'])) {
            AddHistoryItem($_GET['id'], HISTORY_COMMENT, $_POST['comment']);
            header('location: ?id=' . $_GET['id']);
          } else {
?>
<form action="?id=<?php echo $_GET['id']; ?>&amp;action=comment" method="post">
<?php echo $lang['comment']; ?>:<br />
<?php echo GetBBCodePanel('ta_comment'); ?><br />
<textarea name="comment" class="textarea_todo_comment" id="ta_comment"></textarea><br />
<br />
<input type="submit" accesskey="s" value="<?php echo $lang['send']; ?>" />
</form>
<?php
          }
        }
      } elseif ($_GET['action'] == 'file_add') { // Datei hochladen
        // Rechte prfen
        if (!UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD_DOWNLOAD)) {
          ShowError($lang['auth_download_error']);
        } else {
          if (!empty($_FILES['file_upload'])) {
            $error = '';
            if (is_array($cfg['fileupload_exts'])) {
              if (!$file_ext = GetFileExt($_FILES['file_upload']['name'])) {
                $error = $lang['file_type_get_error'];
              } else {
                if (!in_array($file_ext, $cfg['fileupload_exts'])) {
                  $error = str_replace('%s', $file_ext, $lang['file_type_error']);
                }
              }
            }
            if ($error == '') {
              if ($cfg['fileupload_maxsize'] > 0) {
                if ($_FILES['file_upload']['size'] > $cfg['fileupload_maxsize']) {
                  $error = str_replace('%s', FormatFileSize($cfg['fileupload_maxsize']), $lang['file_size_error']);
                }
              }
              if ($error == '') {
                $prefix = 1;
                while (file_exists($cfg['fileupload_dir'] . '/' . $prefix . '_' . $_FILES['file_upload']['name'])) {
                  $prefix++;
                }
                if (!move_uploaded_file($_FILES['file_upload']['tmp_name'], $cfg['fileupload_dir'] . '/' . $prefix . '_' . $_FILES['file_upload']['name'])) {
                  $error = $lang['file_move_error'];
                }
                if ($error == '') {
                  $sql = 'INSERT INTO ' . TABLE_FILES . ' (item_id, file_name, file_prefix, developer_id) VALUES (' . $_GET['id'] . ', "' . $_FILES['file_upload']['name'] . '", ' . $prefix . ', ' . $_SESSION['ptodo_user_id'] . ')';
                  @mysql_query($sql);
                  AddHistoryItem($_GET['id'], HISTORY_FILEADD, $_FILES['file_upload']['name']);
                  header('location: ?id=' . $_GET['id']);
                }
              }
            }
            if (!empty($error)) {
              ShowError($error);
            }
          } else {
            if ($cfg['fileupload_maxsize'] > 0) {
              $input_max = ' maxlength="' . $cfg['fileupload_maxsize'] . '"';
              $info_max = FormatFileSize($cfg['fileupload_maxsize']);
            } else {
              $input_max = '';
              $info_max = $lang['unlimited'];
            }
            if (is_array($cfg['fileupload_exts'])) {
              $info_exts = '*.' . implode(', *.', $cfg['fileupload_exts']);
            } else {
              $info_exts = '*.*';
            }
?>
<b><?php echo $lang['upload_file']; ?>:</b><br />
<br />
<form action="?id=<?php echo $_GET['id']; ?>&amp;action=file_add" method="post" enctype="multipart/form-data">
<?php echo $lang['file']; ?>: <input type="file" name="file_upload"<?php echo $input_max; ?> /><br />
<br />
<?php echo $lang['file_types'] . ': ' . $info_exts; ?><br />
<?php echo $lang['file_size'] . ': ' . $info_max; ?><br />
<br />
<input type="submit" accesskey="s" value="<?php echo $lang['upload']; ?>" />
</form>
<?php
          }
        }
      } elseif ($_GET['action'] == 'file_delete') { // Datei lschen
        // Rechte prfen
        $sql = 'SELECT developer_id FROM ' . TABLE_FILES . ' WHERE file_id=' . (int)$_GET['file'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        if ($row['developer_id'] != $_SESSION['ptodo_user_id'] || !UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD_DOWNLOAD)) {
          ShowError($lang['auth_download_del_error']);
        } else {
          $sql = 'SELECT file_name, file_prefix, developer_id FROM ' . TABLE_FILES . ' WHERE file_id=' . (int)$_GET['file'];
          $query = @mysql_query($sql);
          if (@mysql_num_rows($query) == 0) {
            ShowError(str_replace('%s', (int)$_GET['file'], $lang['file_error']));
          } else {
            $row = @mysql_fetch_array($query);
            if (($row['developer_id'] != $_SESSION['ptodo_user_id'] && !UserIsAdmin($_SESSION['ptodo_user_id'])) || (isset($_POST['no']))) {
              header('location: ?id=' . $_GET['id']);
            } elseif (isset($_POST['yes'])) {
              // Datei entfernen
              unlink($cfg['fileupload_dir'] . '/' . $row['file_prefix'] . '_' . $row['file_name']);
              // Dateieintrag entfernen
              $sql = 'DELETE FROM ' . TABLE_FILES . ' WHERE file_id=' . (int)$_GET['file'];
              @mysql_query($sql);
              // Historyeintrag erstellen
              AddHistoryItem($_GET['id'], HISTORY_FILEDELETE, $row['file_name']);
              header('location: ?id=' . $_GET['id']);
            } else {
?>
<b><?php echo $lang['delete_file']; ?>:</b><br />
<br />
<form action="?id=<?php echo $_GET['id']; ?>&amp;action=file_delete&amp;file=<?php echo (int)$_GET['file']; ?>" method="post">
<?php echo str_replace('%s', $row['file_name'], $lang['delete_file_info']); ?><br />
<br />
<input type="submit" name="yes" value="<?php echo $lang['yes']; ?>" /> <input type="submit" name="no" value="<?php echo $lang['no']; ?>" />
</form>
<?
             }
           }
        }
      } elseif ($_GET['action'] == 'delete') { // Eintrag lschen
        if (($item_author == $_SESSION['ptodo_user_id'] && !UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_DELETE)) || ($item_author != $_SESSION['ptodo_user_id'] && !UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_DELETE_ALL))) {
          ShowError($lang['auth_item_del_error']);
        } elseif (isset($_POST['yes'])) {
          // Eintrag lschen
          $sql = 'DELETE FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
          @mysql_query($sql);
          // History lschen
          $sql = 'DELETE FROM ' . TABLE_HISTORY . ' WHERE item_id=' . $_GET['id'];
          @mysql_query($sql);
          // Abonnierte Verweise lschen
          $sql = 'DELETE FROM ' . TABLE_ITEMWATCH . ' WHERE item_id=' . $_GET['id'];
          @mysql_query($sql);
          // Abhngigkeiten lschen
          $sql = 'DELETE FROM ' . TABLE_ITEMLINK . ' WHERE item_id=' . $_GET['id'] . ' OR linkitem_id=' . $_GET['id'];
          @mysql_query($sql);
          header('location: ?tid=' . $todo_id);
        } else {
?>
<b><?php echo $lang['delete_item']; ?>:</b><br />
<br />
<form action="?id=<?php echo $_GET['id']; ?>&amp;action=delete" method="post">
<?php echo str_replace('%s', $_GET['id'], $lang['delete_item_info']); ?><br />
<br />
<input type="submit" name="yes" value="<?php echo $lang['yes']; ?>" /> <input type="submit" name="no" value="<?php echo $lang['no']; ?>" />
</form>
<?
        }
      } elseif ($_GET['action'] == 'edit') { // Eintrag bearbeiten
        if (($item_author == $_SESSION['ptodo_user_id'] && !UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_EDIT)) || ($item_author != $_SESSION['ptodo_user_id'] && !UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_EDIT_ALL))) {
          ShowError($lang['auth_item_edit_error']);
        } else {
          if (!empty($_POST['title']) && !empty($_POST['desc']) && ForceComments($_POST['comment'], COMMENT_EDIT)) {
            $sql = 'UPDATE ' . TABLE_ITEMS . ' SET item_title="' . $_POST['title'] . '", item_priority=' . $_POST['priority'] . ', item_type=' . $_POST['type'] . ', item_text="' . CheckBBCode($_POST['desc']) . '" WHERE item_id=' . $_GET['id'];
            @mysql_query($sql);
            AddHistoryItem($_GET['id'], HISTORY_EDIT, $_POST['comment']);
            header('location: ?id=' . $_GET['id']);
          } else {
            $notice = $lang['notice'] . ': ' . ($cfg['force_comments'] & COMMENT_EDIT ? $lang['comment_force'] : $lang['comment_optional']);
            if (isset($_POST['send'])) {
              if (($cfg['force_comments'] & COMMENT_EDIT) && (empty($_POST['comment']))) {
                $notice = '<span class="info_warning">' . $notice . '</span>';
              }
              $sql = 'SELECT item_endtime, item_done FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
              $query = @mysql_query($sql);
              $row = @mysql_fetch_array($query);
              $status_open = ($row['item_endtime'] == 0 && $row['item_done'] == 0);
            } else {
              $sql = 'SELECT item_title, item_priority, item_type, item_text, item_endtime, item_done FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
              $query = @mysql_query($sql);
              $row = @mysql_fetch_array($query);
              $status_open = ($row['item_endtime'] == 0 && $row['item_done'] == 0);
              $_POST['title'] = addslashes($row['item_title']);
              $_POST['priority'] = $row['item_priority'];
              $_POST['type'] = $row['item_type'];
              $_POST['desc'] = addslashes($row['item_text']);
            }
            $title_error = $desc_error = '';
            if (isset($_POST['send'])) {
              if (empty($_POST['title'])) {
                $title_error = ' <span class="info_warning">' . $lang['notice'] . ': ' . $lang['empty_title'] . '</span>';
              }
              if (empty($_POST['desc'])) {
                $desc_error = ' <span class="info_warning">' . $lang['notice'] . ': ' . $lang['empty_desc'] . '</span>';
              }
            }
?>
<b><?php echo $lang['edit_item']; ?>:</b><br />
<br />
<form action="?id=<?php echo $_GET['id']; ?>&amp;action=edit" method="post">
<?php echo $lang['title'] . ':' . $title_error; ?><br />
<input type="text" name="title" class="input_text" value="<?php echo HtmlEnt(stripslashes($_POST['title'])); ?>" /><br />
<br />
<?php echo $lang['description'] . ':' . $desc_error; ?><br />
<?php echo GetBBCodePanel('ta_text'); ?><br />
<textarea name="desc" class="textarea_todo_add" id="ta_text"><?php echo HtmlEnt(stripslashes($_POST['desc'])); ?></textarea><br />
<br />
<?php echo $lang['priority'] . ': ' . GetPrioritySelect($_POST['priority']) . '&nbsp;&nbsp;&nbsp;' . $lang['type'] . ': ' . GetTypeSelect($_POST['type'], $status_open); ?><br />
<br />
<?php echo $lang['edit_reason']; ?>:<br />
<?php echo GetBBCodePanel('ta_comment'); ?><br />
<textarea name="comment" class="textarea_todo_comment" id="ta_comment"><?php echo HtmlEnt(isset($_POST['comment']) ? stripslashes($_POST['comment']) : ''); ?></textarea><br />
<?php echo $notice; ?><br />
<br />
<input type="submit" accesskey="s" name="send" value="<?php echo $lang['edit']; ?>" />
</form>
<?
          }
        }
      } else { // Eintrag anzeigen
        $sql = 'SELECT COUNT(user_id) AS UserCount FROM ' . TABLE_ITEMWATCH . ' WHERE user_id=' . $_SESSION['ptodo_user_id'] . ' AND item_id=' . $_GET['id'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $subscribed = ($row['UserCount'] > 0);
        $sql = 'SELECT item_author, item_title, item_priority, item_type, item_text, item_starttime, item_endtime, item_done, developer_id FROM ' . TABLE_ITEMS . ' WHERE item_id=' . $_GET['id'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $author = GetUserName($row['item_author']);
        if ($row['item_author'] == $_SESSION['ptodo_user_id']) {
          $author = '<span class="td_dev_user">' . $author . '</span>';
        }
        $donelink = '';
        if ($row['item_endtime'] == 0) {
          $end_time = $lang['not_closed'];
          $endlink = $lang['item_close'];
        } else {
          $end_time = date('d.m.Y, H:i', $row['item_endtime']) . ' Uhr';
          $endlink = $lang['item_open'];
          $setdone = ($cfg['setdone_bydev'] ? 'developer_id' : 'item_author');
          if ($row['item_done'] == 0 && $row[$setdone] == $_SESSION['ptodo_user_id'] && UserAuth($_SESSION['ptodo_user_id'], $todo_id, ($cfg['setdone_bydev'] ? AUTH_ISDEV : AUTH_ADD))) {
            $donelink = ' | <a href="?id=' . $_GET['id'] . '&amp;action=change_done_end">' . $lang['item_done'] . '</a>';
          }
        }
        if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD | AUTH_ISDEV)) {
          if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ISDEV)) {
            $donelink = '<a href="?id=' . $_GET['id'] . '&amp;action=change_done">' . $endlink . '</a>' . $donelink;
          }
          if (!empty($donelink)) {
            $end_time .= '<span class="no_print"> (' . $donelink . ')</span>';
          }
        }
        if ($row['developer_id'] == 0) {
          $dev = $lang['no_developer'];
          if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ISDEV)) {
            $devlink = $lang['sadd'];
          } else {
            $devlink = '';
          }
        } else {
          $dev = GetUserName($row['developer_id']);
          if ($row['developer_id'] == $_SESSION['ptodo_user_id']) {
            $dev = '<span class="td_dev_user">' . $dev . '</span>';
            $devlink = $lang['remove'];
          } else {
            $devlink = '';
          }
        }
        if (!empty($devlink)) {
          $dev .= '<span class="no_print"> (<a href="?id=' . $_GET['id'] . '&amp;action=change_dev">' . $devlink . '</a>)</span>';
        }
        $title = HtmlEnt($row['item_title']);
        require_once('bbcode.php');
        $text = ParseBBCode(HtmlEnt($row['item_text']));
        if (!empty($_GET['search']) && !empty($_GET['place'])) {
          if ($_GET['place'] == SEARCH_TITLE || $_GET['place'] == SEARCH_TITLETEXT) {
            $title = HighlightSearchString(HtmlEnt($_GET['search']), $title);
          }
          if ($_GET['place'] == SEARCH_TEXT || $_GET['place'] == SEARCH_TITLETEXT) {
            $text = HighlightSearchString($_GET['search'], $text);
          }
        }
        if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_VIEW_HISTORY)) {
          $subscribed_link = '<tr><td>' . $lang['subscribed'] . ':&nbsp;</td><td>';
          if ($subscribed) {
            $subscribed_link .= $lang['yes'] . ' (<a href="?id=' . $_GET['id'] . '&amp;action=subscribe">' . $lang['no_subscribe'] . '</a>)';
          } else {
            $subscribed_link .= $lang['no'] . ' (<a href="?id=' . $_GET['id'] . '&amp;action=subscribe">' . $lang['subscribe'] . '</a>)';
          }
          $sql_2 = 'SELECT COUNT(user_id) AS UserCount FROM ' . TABLE_USERS . ' WHERE user_email!="" AND user_id=' . $_SESSION['ptodo_user_id'];
          $query_2 = @mysql_query($sql_2);
          $row_2 = @mysql_fetch_array($query_2);
          if ($row_2['UserCount'] == 0) {
            $subscribed_link .= ' <span class="info_warning">' . $lang['no_email'] . '</span>';
          }
          $subscribed_link .= '</td></tr>';
        } else {
          $subscribed_link = '';
        }
        $status_open = ($row['item_endtime'] == 0 && $row['item_done'] == 0);
?>
<table cellpadding="2" cellspacing="0">
<tr><td><?php echo $lang['id']; ?>:&nbsp;</td><td>#<?php echo $_GET['id']; ?></td></tr>
<tr><td><?php echo $lang['title']; ?>:&nbsp;</td><td><?php echo $title; ?></td></tr>
<tr><td><?php echo $lang['author']; ?>:&nbsp;</td><td><?php echo $author; ?></td></tr>
<tr><td><?php echo $lang['priority']; ?>:&nbsp;</td><td><?php echo $lang[GetPriorityName($row['item_priority'])]; ?></td></tr>
<tr><td><?php echo $lang['type']; ?>:&nbsp;</td><td><?php echo $lang[GetTypeName($row['item_type'], $status_open)]; ?></td></tr>
<tr><td><?php echo $lang['item_added']; ?>:&nbsp;</td><td><?php echo date($lang['time_format'], $row['item_starttime']); ?></td></tr>
<tr><td><?php echo $lang['item_completed']; ?>:&nbsp;</td><td><?php echo $end_time; ?></td></tr>
<tr><td><?php echo $lang['developer']; ?>:&nbsp;</td><td><?php echo $dev; ?></td></tr>
<?php echo $subscribed_link; ?>
<tr><td valign="top"><?php echo $lang['description']; ?>:&nbsp;</td><td><?php echo $text; ?><br /><br /></td></tr>
<?php
        $actions = '';
        if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_VIEW_HISTORY) && UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD | AUTH_ISDEV)) {
          $actions = '<a href="?id=' . $_GET['id'] . '&amp;action=comment">' . $lang['add_comment'] . '</a>';
        }
        if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD_DOWNLOAD)) {
          if (!empty($actions)) {
            $actions .= ' - ';
          }
          $actions .= '<a href="?id=' . $_GET['id'] . '&amp;action=file_add">' . $lang['upload_file'] . '</a>';
        }
        if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD | AUTH_ISDEV) && ($_SESSION['ptodo_user_id'] == $row['item_author'] || !$cfg['adddependence_byauthor'])) {
          if (!empty($actions)) {
            $actions .= ' - ';
          }
          $actions .= '<a href="?id=' . $_GET['id'] . '&amp;action=dependence_add">' . $lang['dependence_add'] . '</a>';
        }
        if (!empty($actions)) {
          echo '<tr><td colspan="2"><span class="no_print">' . $actions . '<br /><br /></span></td></tr>';
        }
        
        // Abhngigkeiten auflisten
        $sql = 'SELECT linkitem_id FROM ' . TABLE_ITEMLINK . ' WHERE item_id=' . $_GET['id'];
        $query = @mysql_query($sql);
        if (@mysql_num_rows($query) > 0) {
          echo '<tr><td valign="top">' . $lang['dependences'] . ':&nbsp;</td><td valign="top"><table cellpadding="2" cellspacing="0"><tr><td>#</td><td>' . $lang['title'] . '</td><td></td></tr>';
          $link_ids = array();
          while ($row = @mysql_fetch_array($query)) {
            $link_ids[] = $row['linkitem_id'];
          }
          $sql_where = 'item_id=' . $link_ids[0];
          for ($i = 1; $i < count($link_ids); $i++) {
            $sql_where .= ' OR item_id=' . $link_ids[$i];
          }
          for ($i = STATUS_OPEN; $i <= STATUS_DONE; $i++) {
            $item_data = GetItemDataByStatus($i);
            $sql = 'SELECT item_id, item_title FROM ' . TABLE_ITEMS . ' WHERE (' . $sql_where . ') AND ' . $item_data['sql_where'] . ' ORDER BY item_id DESC';
            $query = @mysql_query($sql);
            $count = @mysql_num_rows($query);
            if ($count > 0) {
              while ($row = @mysql_fetch_array($query)) {
                echo '<tr><td class="td_status_' . $item_data['style'] . '">' . $row['item_id'] . '</td><td><a href="?id=' . $row['item_id'] . '">' . HtmlEnt($row['item_title']) . '</a></td><td>' . (($_SESSION['ptodo_user_id'] == $row['item_author'] || !$cfg['adddependence_byauthor']) ? ' (<a href="?id=' . $_GET['id'] . '&amp;action=dependence_remove&amp;item=' . $row['item_id'] . '">' . $lang['remove'] . '</a>)' : '') . '</td></tr>';
              }
            }
          }
          echo '</table><br /></td></tr>';
        }
        // Abhngigkeitsrckbeziehungen auflisten
        $sql = 'SELECT item_id FROM ' . TABLE_ITEMLINK . ' WHERE linkitem_id=' . $_GET['id'];
        $query = @mysql_query($sql);
        if (@mysql_num_rows($query) > 0) {
          echo '<tr><td valign="top">' . $lang['dependences_reg'] . ':&nbsp;</td><td valign="top"><table cellpadding="2" cellspacing="0"><tr><td>#</td><td>' . $lang['title'] . '</td></tr>';
          $link_ids = array();
          while ($row = @mysql_fetch_array($query)) {
            $link_ids[] = $row['item_id'];
          }
          $sql_where = 'item_id=' . implode(' OR item_id=', $link_ids);
          $item_data = GetItemDataByStatus($i);
          $sql = 'SELECT item_id, item_title, item_priority FROM ' . TABLE_ITEMS . ' WHERE (' . $sql_where . ') ORDER BY item_priority DESC';
          $query = @mysql_query($sql);
          $count = @mysql_num_rows($query);
          if ($count > 0) {
            while ($row = @mysql_fetch_array($query)) {
              echo '<tr><td class="priority_' . GetPriorityName($row['item_priority']) . '">' . $row['item_id'] . '</td><td><a href="?id=' . $row['item_id'] . '">' . HtmlEnt($row['item_title']) . '</a></td></tr>';
            }
          }
          echo '</table><br /></td></tr>';
        }
        // Dateien auflisten
        if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_VIEW_DOWNLOAD)) {
          $sql = 'SELECT file_id, file_name, file_prefix, developer_id, file_hits FROM ' . TABLE_FILES . ' WHERE item_id=' . $_GET['id'] . ' ORDER BY file_id DESC';
          $query = @mysql_query($sql);
          if (@mysql_num_rows($query) > 0) {
            echo '<tr><td valign="top">' . $lang['files'] . ':&nbsp;</td><td>';
            while ($row = @mysql_fetch_array($query)) {
              $filename = $cfg['fileupload_dir'] . '/' . $row['file_prefix'] . '_' . $row['file_name'];
              if ($row['developer_id'] == $_SESSION['ptodo_user_id'] && UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_ADD_DOWNLOAD)) {
                $delete = ' | <a href="?id=' . $_GET['id'] . '&amp;action=file_delete&amp;file=' . $row['file_id'] . '">' . $lang['delete_small'] . '</a>';
              } else {
                $delete = '';
              }
              echo '#' . $row['file_id'] . ' <a href="?fid=' . $row['file_id'] . '">' . $lang['download'] . '</a> - [' . $row['file_name'] . ' | ' . FormatFileSize(@filesize($filename)) . ' | ' . $lang['hits'] . ': ' . $row['file_hits'] . $delete . ']<br />';
            }
            echo '<br /></td></tr>';
          }
        }
        // History anzeigen
        if (UserAuth($_SESSION['ptodo_user_id'], $todo_id, AUTH_VIEW_HISTORY)) {
          echo '<tr><td valign="top">' . $lang['history'] . ':&nbsp;</td><td>';
          $sql = 'SELECT developer_id, history_action, history_time, history_text FROM ' . TABLE_HISTORY . ' WHERE item_id=' . $_GET['id'] . ' ORDER BY history_time DESC';
          $query = @mysql_query($sql);
          if (@mysql_num_rows($query) == 0) {
            echo $lang['no_history'];
          } else {
            echo '<table cellpadding="1" cellspacing="0">';
            while ($row = @mysql_fetch_array($query)) {
              $dev = GetUserName($row['developer_id']);
              $history = GetHistoryAction($row['history_action'], $row['history_text']);
              echo '<tr><td valign="top" style="white-space:nowrap">' . date($lang['time_format'], $row['history_time']) . '</td><td valign="top">-</td><td valign="top" style="white-space:nowrap">' . str_replace('%s', $dev, $history['action']) . '</td>' . (empty($history['text']) ? '<td colspan="2">&nbsp;' : '<td valign="top">-</td><td>' . $lang['comment'] . ': ' . $history['text']) . '</td></tr>';
            }
            echo '</table>';
          }
          echo '</td></tr>';
        }
?>
</table>
<?php
      }
    }
  }
?>