<?php
  // Konfiguration einbinden
  require('config.php');
  
  // Datenbankverbindung herstellen
  $connect = @mysql_connect($dbHost, $dbUser, $dbPass) or die('Konnte keine Verbindung zum Datenbankserver aufbauen!');
  $selectDB = @mysql_select_db($dbName, $connect) or die('Konnte die Datenbank <b>' . $dbName . '</b> nicht auswhlen!');
  unset($dbHost, $dbUser, $dbPass);
  
  // Konstanten einbinden
  require('modules/constants.php');
  
  // Neue Version
  $version = '2.1.6';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>pToDo Update nach v<?php echo $version; ?></title>
<link rel="stylesheet" type="text/css" href="screen.css" />
</head>
<body>
<div id="div_login" style="width:400px">
<b style="text-decoration:underline">pToDo Update nach v<?php echo $version; ?>:</b><br />
<br />
<?php
  if (isset($_POST['send'])) {
    // SQL Queries zusammenstellen
    $sql = array();
    switch ($_POST['version']) {
      case 14:
        $sql[] = 'CREATE TABLE ' . TABLE_POSTS . ' (post_id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT, navitem_id MEDIUMINT(8) UNSIGNED NOT NULL, post_parent INT(10) UNSIGNED NOT NULL, post_child INT(10) UNSIGNED NOT NULL, post_time INT(11) UNSIGNED NOT NULL, post_author MEDIUMINT(8) UNSIGNED NOT NULL, post_title VARCHAR(255) NOT NULL, post_text TEXT NOT NULL, PRIMARY KEY (post_id)) TYPE=MyISAM;';
        $sql[] = 'CREATE TABLE ' . TABLE_ITEMWATCH . ' (user_id MEDIUMINT(8) UNSIGNED NOT NULL, item_id INT(10) UNSIGNED NOT NULL) TYPE=MyISAM;';
        $sql[] = 'ALTER TABLE ' . TABLE_FILES . ' CHANGE file_name file_name VARCHAR(255) NOT NULL;';
        $sql[] = 'ALTER TABLE ' . TABLE_ITEMS . ' CHANGE item_title item_title VARCHAR(255) NOT NULL;';
        $sql[] = 'ALTER TABLE ' . TABLE_ITEMS . ' ADD item_priority TINYINT(1) UNSIGNED NOT NULL AFTER item_text;';
        $sql[] = 'ALTER TABLE ' . TABLE_NAVITEMS . ' CHANGE navitem_title navitem_title VARCHAR(255) NOT NULL;';
        $sql[] = 'ALTER TABLE ' . TABLE_USERS . ' CHANGE user_name user_name VARCHAR(255) NOT NULL;';
        $sql[] = 'ALTER TABLE ' . TABLE_USERS . ' ADD user_email VARCHAR(255) NOT NULL AFTER user_password;';
        $sql[] = 'UPDATE ' . TABLE_ITEMS . ' SET item_priority=3;';
      case 15:
      case 16:
        $sql[] = 'CREATE TABLE ' . TABLE_ITEMLINK . ' (item_id  INT(10) UNSIGNED NOT NULL, linkitem_id INT(10) UNSIGNED NOT NULL) TYPE=MyISAM;';
      case 17:
      case 18:
      case 19:
      case 20:
        $sql[] = 'CREATE TABLE ' . TABLE_GROUPS . ' (group_id MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT, group_name VARCHAR(255) NOT NULL, PRIMARY KEY (group_id)) TYPE=MyISAM;';
        $sql[] = 'INSERT INTO ' . TABLE_GROUPS . ' VALUES (\'\', \'Default\');';
        $sql[] = 'INSERT INTO ' . TABLE_GROUPS . ' VALUES (\'\', \'Guests\');';
        $sql[] = 'ALTER TABLE ' . TABLE_USERS . ' ADD group_id MEDIUMINT(8) UNSIGNED NOT NULL AFTER user_id;';
        $sql[] = 'UPDATE ' . TABLE_USERS . ' SET group_id=1;';
        $sql[] = 'CREATE TABLE ' . TABLE_RIGHTS . ' (group_id MEDIUMINT(8) UNSIGNED NOT NULL, navitem_id INT(10) UNSIGNED NOT NULL, rights_auth INT(10) UNSIGNED NOT NULL) TYPE=MyISAM;';
        $sql[] = 'CREATE TABLE ' . TABLE_CONFIG . ' (config_name varchar(255) NOT NULL default \'\', config_value varchar(255) NOT NULL default \'\') TYPE=MyISAM;';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'admin_email\', \'\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'site_title\', \'Projektaufgaben sinnvoll im Team planen\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'site_subtitle\', \'\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'setdone_bydev\', \'0\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'adddependence_byauthor\', \'0\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'force_comments\', \'1\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'navibox_width\', \'100\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'lastitems_count\', \'10\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'items_per_page\', \'25\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'fileupload_dir\', \'file_upload\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'fileupload_exts\', \'txt,jpg,png,zip\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'fileupload_maxsize\', \'102400\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'guest_mode\', \'0\');';
        $sql[] = 'ALTER TABLE ' . TABLE_NAVITEMS . ' ADD navitem_linktarget TINYINT(1) unsigned NOT NULL;';
        $sql[] = 'UPDATE ' . TABLE_NAVITEMS . ' SET navitem_linktarget=1;';
      case 211:
      case 212:
      case 213:
        $sql[] = 'ALTER TABLE ' . TABLE_ITEMS . ' ADD item_type TINYINT(1) unsigned NOT NULL AFTER item_priority;';
        $sql[] = 'UPDATE ' . TABLE_ITEMS . ' SET item_type=1;';
        $sql[] = 'CREATE TABLE ' . TABLE_VERSIONS . ' (version_id int(10) unsigned NOT NULL auto_increment, version_time int(11) unsigned NOT NULL default \'0\', navitem_id mediumint(8) unsigned NOT NULL default \'0\', version_text varchar(255) NOT NULL default \'\', PRIMARY KEY (version_id)) TYPE=MyISAM;';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'type_prefix_other\', \'[ * ]\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'type_prefix_feature\', \'[ADD]\');';
        $sql[] = 'INSERT INTO ' . TABLE_CONFIG . ' VALUES (\'type_prefix_bugfix\', \'[FIX]\');';
        $sql[] = 'UPDATE ' . TABLE_CONFIG . ' SET config_value=15 WHERE config_name="force_comments" AND config_value=1;';
        $sql[] = 'ALTER TABLE ' . TABLE_NAVITEMS . ' CHANGE navitem_linktarget navitem_linktarget TINYINT(1) UNSIGNED DEFAULT \'0\' NOT NULL;';
      case 214:
        $sql[] = 'ALTER TABLE ' . TABLE_FILES . ' ADD file_hits INT(10) NOT NULL;';
    }

    if (count($sql) > 0) {
      $error = false;
      
      foreach ($sql as $sql_query) {
        if (!@mysql_query($sql_query)) {
          $error = true;
          break;
        }
      }
      
      if ($error) {
        echo 'Ein Fehler ist aufgetreten: ' . mysql_error();
      } else {
        echo 'Update abgeschlossen. L&ouml;schen Sie diese Datei nun von Ihrem Server!';
      }
    } else {
      echo 'Kein Update der Datenbank n&ouml;tig. L&ouml;schen Sie diese Datei nun von Ihrem Server!';
    }
  } else {
?>
Dieses Update wird ihre Tabellen an die Version <?php echo $version; ?> anpassen.<br />
<br />
Erstellen Sie vor dem Update ein Backup der Tabellen.<br />
<br />
<form action="?" method="post">
Bitte geben Sie die Versionsnummer ihrer vorherigen Installation an:<br />
<br />
<select name="version">
<option value="215">2.1.5</option>
<option value="214">2.1.4</option>
<option value="213">2.1.3</option>
<option value="212">2.1.2</option>
<option value="211">2.1.1</option>
<option value="21">2.1</option>
<option value="20">2.0</option>
<option value="19">1.9</option>
<option value="18">1.8</option>
<option value="17">1.7</option>
<option value="16">1.6</option>
<option value="15">1.5</option>
<option value="14">1.4</option>
</select><br />
<br />
<input type="submit" name="send" value="Update starten" />
</form>
<?php
  }
?>
</div>
<div id="div_copyright">
copyright &copy; 2005 - 2006 <a href="http://pr0g.net" target="_blank">pr0g.net</a>
</div>
</body>
</html>